#!/usr/bin/perl
# +========================================================================+
# || CAT CipUX Administration Tool                                        ||
# || Webmin module: applicationform.cgi                                   ||
# || for administration of CAT and CipUX                                  ||
# || (c) 2001,2002,2003,2005 by Christian Kuelker                         ||
# || License: GPLv2                                                       ||
# +========================================================================+

package applicationform_cgi;

do '../web-lib.pl';
&init_config();

use CipUX::CiBot;
use CipUX::Cat;
use CipUX::Task;
use CipUX::Conversion;

my $BRAND    = "cipworx";
my $PROJECT  = "cipux";
my $SCRIPT   = "applicationform.cgi";

my $error = 0; # if error = 1
my $set_applicationform = 0; # if = 0 applicationform; = 1 set net applicant data
my  $application_form_send=0;
my $msg ='';
my $new_uid="";

&log($SCRIPT,"="x76);

# +=======================================================================+
# || check if the LDAP is there                                          ||
# +=======================================================================+
if($cibot_ldap_status eq 'offline'){
  &cat_header($remote_user,\&header,\&help_search_link,\&text);
  print &cat_error(&text('_error_no_ldap_connect'));
  exit(0);
}

&cibot_get_ldap_config();
&log($SCRIPT,"- remote user [$remote_user]");

#if($result ne 'ok'){
#  print "<h1>$text('access_denied')}</h1>";
#  #print $text('access_denied_explanation',$remote_user,$role);
 # &cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});
 # exit(0);
#}
                        ;
my ($result,$role) = &cibot_acl($SCRIPT,$remote_user);
&cat_header($remote_user,\&header,\&help_search_link,\&text);

# hostname, user, arrayref
#print &cat_status_line(&get_system_hostname(),
#                       $remote_user." ($role)",
#		       [
#			&text('server'),
#			&text('status'),
#			$cipux{Customer},
#			&text('date'),
#			&text('version'),
#                        $ldap{CipUX}{CipUX_Institution_Name}
#		       ]
#		      );

# +=======================================================================+
# ||  CAT ACL check                                                      ||
# +=======================================================================+
if($result ne 'ok'){
  print "<h1>".&text('access_denied')."</h1>";
  my $error = &text('access_denied_explanation',
                   "<b>$remote_user</b>",
                   "<b>$role</b>");
  &log($SCRIPT,$error);
  print &cat_error($error);
  &cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});
  exit(0)
}

# +=======================================================================+
# || Environment                                                         ||
# +=======================================================================+
&log($SCRIPT,"- webmin: ReadParse...");
ReadParse();# webmin

my $system = $in{'system'}    if defined($in{'system'});# system

foreach(sort keys %in){
  &log($SCRIPT,"- IN: [$_] = [$in{$_}]") if defined($in{$_});
}

# =========================================================================+
#                    Change Line                                          ||
# =========================================================================+

#if(defined($in{save_admin})){
#  &log($SCRIPT,"- got action eq save_admin");
# &cibot_change_userdata_conf(
#   $in{attribute},
#   $in{data},
#   $in{application}
# );
#}

# =========================================================================+
#                    Config                                               ||
# =========================================================================+
my @user_data_option = qw(hidden visible editable);
my @user_application_option = qw(mandatory optional skip);

my(
   $userdata_aref,
   $userdata_href,
   $user_application_form_href
   ) = cibot_parse_userdata_conf;

# =========================================================================+
#                    check passwords                                      ||
# =========================================================================+
if($in{save_applicationform} eq &text("save")){
  &log($SCRIPT,"* check passowrds");
  if(defined($in{PASSWORD_1})){
    # password 1 is defined
    if(defined($in{PASSWORD_2})){
      # password 2 is defined
      if($in{PASSWORD_1} ne "" and $in{PASSWORD_2} ne ""){
        # passwords are not empty
	if($in{PASSWORD_1} eq $in{PASSWORD_2}){
	  #password ar equal
          $set_applicationform=1;
	  
	}else{
          # ERROR passwords ar not equal
	  $error="error_password_mismatch";
	  
	}
      }else{
        # ERROR password is empty!
        $error="error_empty_password_given";
	
      }
    }else{
      # ERROR password 2 is not defined! 
       $error="error_password_not_defined";

    }
  }else{
     # ERROR password 1 is not defined! 
     $error="error_password_not_defined";
  }	  
}


# =========================================================================+
# ||                         check data                                   ||
# =========================================================================+
if($set_applicationform and not $error){
  &log($SCRIPT,"* check data");
  foreach my $attribute (@$userdata_aref){
    if($$user_application_form_href{$attribute} eq "mandatory"){
      if($attribute ne "PASSWORD"){	    
        &log($SCRIPT, "- test [$attribute]");
        if($in{$attribute} eq ''){
	  &log($SCRIPT, "raise error for attribute [$attribute] [".&text($attribute)."]");
          $error="error_empty_field";
          $msg=&text($attribute);
        }
      }
    }	    
  }	  
  if(not defined($in{cipuxFirstname})){
    $error="error_empty_firstname";
  }
  if(not defined($in{cipuxLastname})){
    $error="error_empty_lastname";
  }
}	

  
# =========================================================================+
# ||                         ERROR                                        ||
# =========================================================================+
if($error){
	#print ERROR;
  if($msg eq ''){
    print &cat_error(&text($error));
    &log($SCRIPT,"ERROR: $error [".&text($error)."]");
  }else{
    print &cat_error(&text($error,$msg));
    &log($SCRIPT,"ERROR: $error [".&text($error,$msg)."]");
 }
}

# =========================================================================+
# ||                         SET DATA                                     ||
# =========================================================================+
#

#cipux_task_create_applicant firstname lastname role password
if(not $error and  $set_applicationform){

# conversion
foreach (keys %in){
  $in{$_} = &conversion_trim($in{$_});
  if($_ eq 'PASSWORD_1'  or $_ eq 'PASSWORD_2'){
     $in{$_} = &conversion_password($in{$_});
  }elsif($_ eq 'cipuxMail'){
	  $in{$_} = &conversion_mail($in{$_})
  }else{
     $in{$_} = &conversion_name($in{$_});
  }
}

print &cat_table_header(2,$tb,&text('the_following_data_was_send_to_our_system'));
foreach my  $attribute (@$userdata_aref){
  if($attribute eq 'PASSWORD_1'  or $attribute eq 'PASSWORD_2' or $attribute eq 'save_applicationform'){
   #
  }else{
    if(defined(&text($attribute))){
      if($attribute eq 'PASSWORD'){
        print &cat_table_row([1,0],[$tb,$tb], [&text($attribute),&text('not_displayed')]);
      }elsif($in{$attribute} ne ''){
        print &cat_table_row([1,0],[$tb,$tb], [&text($attribute),$in{$attribute}]);
      }else{
        print &cat_table_row([1,0],[$tb,$tb], [&text($attribute),"&nbsp;"]);
      }
    }
  }
}
print &cat_table_footer ."<br>";


$new_uid = &cipux_task_create_applicant('cgi',$in{cipuxFirstname},$in{cipuxLastname},'student',$in{PASSWORD_1});
&log($SCRIPT,"CMD [cipux_task_create_applicant $in{cipuxFirstname} $in{cipuxLastname} 'student' $in{PASSWORD_1}]");
chomp($new_uid);
foreach my $attribute (@$userdata_aref){
  if(defined($in{$attribute})){
    my $cmd = "cipux_set_value -u $new_uid -e $attribute -v '$in{$attribute}'";
    &log($SCRIPT,"CMD [$cmd]");
    `$cmd`; 
  }
  $application_form_send=1;
}
}
# =========================================================================+
# ||                         Main                                         ||
# =========================================================================+
if(not $application_form_send){ 	
  my $institution = ''; 
   $institution = $ldap{CipUX}{CipUX_Institution_Name} if defined($ldap{CipUX}{CipUX_Institution_Name});
  my $office = "";
  $office=$ldap{CipUX}{CipUX_Office} if defined($ldap{CipUX}{CipUX_Office});

  print "<center>".&text('applicationform_intro1',$institution)."</center>";
  print "<br><center><table cellpadding=5 cellspacing=5><tr bgcolor='#999999'><td><ol>";
  print "<li>".&text('applicationform_intro2')."</li>";
  print "<li>".&text('applicationform_intro3')."</li>";
  print "<li>".&text('applicationform_intro4')."</li>" if not $cipux{CipUX_Applicationform_Auto_Apply};
  print "</ol>";
  print "<b>".&text('applicationform_intro_office',$office)."</b>" if not $cipux{CipUX_Applicationform_Auto_Apply};

  print "</td></tr></table><br>";
  print &text('application_form_warning')."</center><br>";

  print "<form method=post action='applicationform.cgi'>";
  print &cat_table_header(2,$tb,&text('applicationform'));
  foreach my $attribute (@$userdata_aref){
    my $value="";	  
    if(defined($in{$attribute})){
       $value = "value='$in{$attribute}'";	    
    }	    
    if($$user_application_form_href{$attribute} eq "mandatory"){
      if($attribute eq "PASSWORD"){
        print &cat_table_row([1,0],[$tb,$tb], [&text('new_password1'), "<input type=password size=80 name='".$attribute."_1' $value>"]);
        print &cat_table_row([1,0],[$tb,$tb], [&text('new_password2'), "<input type=password size=80 name='".$attribute."_2' $value>"]);
      }else{
        print &cat_table_row([1,0],[$tb,$tb], [&text($attribute), "<input type=text size=80 name='$attribute' $value>"]);
      }
    }
    if($$user_application_form_href{$attribute} eq "optional"){
      if($attribute eq "PASSWORD"){
        print &cat_table_row([1,0],[$tb,$tb], [&text('new_password1')." *", "<input type=password size=80 name='".$attribute."_1' $value>"]);
        print &cat_table_row([1,0],[$tb,$tb], [&text('new_password2')." *", "<input type=password size=80 name='".$attribute."_2' $value>"]);
      }else{
        print &cat_table_row([1,0],[$tb,$tb], [&text($attribute)." *", "<input type=text size=80 name='$attribute' $value>"]);
      }
    }
  }
   print &cat_table_footer ."<br>";
   print  "<input type=submit name=save_applicationform value=\"".&text('save')."\"> ".&text('please_wait');
   print "</form>\n";
   print &cat_explain_message("*: ".&text('optional'),$cb);
 }else{
  print &text("applicationform_transmitted",$new_uid,$ldap{CipUX}{CipUX_Office});
  print "<br><br>";
  print "<img src='/cat/images/left.png' border=0>";
  print "<a href='/cat/applicationform.cgi'>".&text('next_apply_for_admission')."</a>";
}

# +=======================================================================+
# || Footer                                                              ||
# +=======================================================================+
#&cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});

exit(0);
