#!/usr/bin/perl
# +========================================================================+
# || CAT CipUX Adminstration Tool                                         ||
# || Webmin module: clientadmin.cgi                                       ||
# || Register Computer Clients                                            ||
# || (c) 2001,2002,2003,2005 Christian Kuelker                            ||
# || License: GPL version 2 or later                                      ||
# +========================================================================+

package clientadmin_cgi;

do '../web-lib.pl';
&init_config();

use CipUX::CiBot;
use CipUX::Conversion;
use CipUX::Cat;
use CipUX::Task;

my $BRAND   = "cipworx";
my $PROJECT = "cipux";
my $SCRIPT  = "clientadmin.cgi";

#my $PART    = "Global";
#my $BUILD   = "2.0-2-Mon May 10 23:38:53 CEST 2004;";
#my $DEBUG   = 0;
#my $explain = "#1a9102";
#my $red     = "#ff0000";
#my $blue    = "#0000ff";
#my $green   = "#136302";
#my $warning = "#ee2222";

&log($SCRIPT,"="x76);

# +=======================================================================+
# || check if the LDAP is there                                          ||
# +=======================================================================+
if($cibot_ldap_status eq 'offline'){
  &cat_header($remote_user,\&header,\&help_search_link,\&text);
  print &cat_error(&text('_error_no_ldap_connect'));
  exit(0);
}

&cibot_get_ldap_config();

my ($result,$role) = &cibot_acl($SCRIPT,$remote_user);
&cat_header($remote_user,\&header,\&help_search_link,\&text);

# hostname, user, arrayref
print &cat_status_line(&get_system_hostname(),
                       "$remote_user ($role) -> $result",
		       [
			&text('server'),
			&text('status'),
			$cipux{Customer},
			&text('date'),
			&text('version'),
                        $ldap{CipUX}{CipUX_Institution_Name}
		       ]
		      );

# +=======================================================================+
# ||  CAT ACL check                                                      ||
# +=======================================================================+
if($result ne 'ok'){
  print "<h1>".&text('access_denied')."</h1>";
  my $error = &text('access_denied_explanation',
                   "<b>$remote_user</b>",
                   "<b>$role</b>");
  &log($SCRIPT,$error);
  print &cat_error($error);
  &cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});
  exit(0)
}

# +=======================================================================+
# || Environment                                                         ||
# +=======================================================================+
&log($SCRIPT,"- ReadParse...");
ReadParse();# webmin

my $action    = $in{'action'} if defined($in{'action'});# action
&log($SCRIPT,"- \$action = [$action]");

foreach(sort keys %in){
  &log($SCRIPT,"- IN: [$_] = [$in{$_}]") if defined($in{$_});
}

# +=======================================================================+
# || Prepare                                                             ||
# +=======================================================================+

# cipux_task_create_machine MID 
#                           mac_address 
#                           room_name 
#                           client_number 
#                           master 
#                           image_slot_number 
#                           hardware_type_number
my @col = qw(  
               cipuxClientNumber
               cipuxMacAddress
               cipuxRoomName
               cipuxMaster
               cipuxImageSlotNumber
               cipuxHardwareTypeNumber
            );

my @room = `cipux_task_list_rooms`;

my @output=();
# +=======================================================================+
# || Main                                                                ||
# +=======================================================================+

# .-----------------------------------------------------------------------.
# | New client                                                            |
# .-----------------------------------------------------------------------.
# TODO: migrate this if
if(defined($in{'apply'})){
  my $values="";
  &log($SCRIPT,"APPLY: new client");
  # IN: (cipuxMacAddress): '00:00:00:00:00:00'
  # IN: (cipuxClientNumber): '253'
  # IN: (cipuxMaster): 'FALSE'
  # IN: (apply): 'Eingabe'
  # IN: (cipuxRoomName): 'Raum-e51'

  # add.pl -m --attribute cipuxMacAddress='00:01:03:BF:c1:9f' --attribute cipuxRoomName=Raum-e52 --attribute cipuxClientNumber=100
  #cipux_task_create_machine MID mac_address room_name client_number image_slot_number hardware_type_number
  my $cmd = "cipux_task_create_machine  C_".$in{cipuxRoomName}."_".$in{cipuxClientNumber}." ";
  foreach (@col){
    chomp;	  
    $cmd .= " '$in{$_}' ";
    $values .= " <b>$_: $in{$_}</b><br>";
    print "ERROR: $_ is empty!<br>" if not defined($_);
  }
  
  # my $command = "/usr/bin/cipux_add -m ";
  #foreach my $c (@col){
  #  chomp($c);
  #  $values .= " <b>$c: $in{$c}</b><br>";
  #  print "ERROR: $c is empty!<br>" if not defined($c);
  #  $command .= "--attribute $c='$in{$c}' ";
  #}
  #&log($SCRIPT,"CMD ($command)");
  @output = `$cmd`;
  print "<hr noshade>";
  if($output[0]=~m/ERROR/){
    foreach(@output){
      print "ERROR: $_<br>";
    }
  }else{
    &log($SCRIPT,"CMD '$cmd'");
    print "$text{'clientadmin_created'}: <br>$values<br>";
  }
 #  update_dhcpd();
  print "<hr noshade><br>";

}

# .-----------------------------------------------------------------------.
# | Change client                                                         |
# .-----------------------------------------------------------------------.
# TODO: migrate this if
if(defined($in{'change'})){
  &log($SCRIPT,"CHANGE ");
  print "<hr noshade>";
  print "<b>$in{'machine'}</b>:<br><ul>";
  foreach my $c (@col){
    if($c ne 'cipuxRoomName' and $c ne 'cipuxClientNumber'){
      my $command ="cipux_set_value ";
      $command .= "-e '$c' -m '$in{'machine'}' -v '$in{$c}'";
      &log($SCRIPT,"CMD '$command'");
      @output=`$command`;
      if($output[0]=~m/ERROR/){
        foreach(@output){
          print "ERROR: $_<br>";
        }
      }else{
        print "<li>$text{'clientadmin_value_changed'}: <b>$in{$c}</b><br>";
      }
    }
  }
  update_dhcpd();
  print "</ul><hr noshade><br>";
}
# .-----------------------------------------------------------------------.
# | Delete client                                                         |
# .-----------------------------------------------------------------------.
# TODO: migrate this if
if(defined($in{'delete'})){
  &log($SCRIPT,"DELETE");
  my $command ="cipux_del ";
     $command .= "-m '$in{'machine'}'";
  &log($SCRIPT,"CMD '$command'");
  @output=`$command`;
  if($output[0]=~m/ERROR/){
    foreach(@output){
      print "ERROR: $_<br>";
    }
  }else{
    print "<li>$text{'clientadmin_client_deleted'}: <b>$in{'machine'}</b><br>";
  }
  update_dhcpd();
}
# .-----------------------------------------------------------------------.
# | Prepare 2                                                             |
# .-----------------------------------------------------------------------.
my @machine = `cipux_task_list_machines`;
# TODO: write ERROR, if no machine!

my @number = ($ldap{CipUX}{CipUX_Client_IP_Range_Start} .. $ldap{CipUX}{CipUX_Client_IP_Range_End});
my %number = ();

#$cmd = "ls /tftpboot/cipux/image";
#&log($SCRIPT,"CMD '$cmd'");
#my @#dir = `$cmd`;
#foreach(@dir){
#  &log($SCRIPT,"DIR $_");
#}
my %image=();
foreach(@dir){# TODO: @dir is NOT defined!
  if(/\.tar\.gz$/){
    chomp();
    my $last_name=$_;
    s/_\d+\.tar\.gz$|\.tar\.gz$//g;
    $image{$_}=$last_name;
  }
}
$image{'default'}="default";

# TODO: use VAR
my @hardwaretype = ('001' .. '999');
my @image = ('001' .. '999');

# get image slot names
$cmd = "cipux_get_value -S -e cipuxImageSlotName";
my %image_slot_name = ();
my @image_slot_name = `$cmd`;
foreach (@image_slot_name){
  chomp();
  my ($key,$value) = split("\t");
  $image_slot_name{$key} = $value;
  &log($SCRIPT,"image slot name ($key)=>($value)");
}

# get hardware type names
$cmd = "cipux_get_value -T -e cipuxHardwareTypeName";
my %hardware_type_name = ();
my @hardware_type_name = `$cmd`;
foreach (@hardware_type_name){
  chomp();
  my ($key,$value) = split("\t");
  $hardware_type_name{$key} = $value;
  &log($SCRIPT,"hardware type name ($key)=>($value)");
}

# .-----------------------------------------------------------------------.
# | Main view                                                             |
# .-----------------------------------------------------------------------.
my $my_error = 0;
my @my_error = ();
my $client_room="";
my $client_number="";
my $only_one_cipux_master=0;
print "<h1>$text{'clientadmin_title'}</h2>";
print "<table border=1>";
print "<tr $tb>";
foreach (@col){chomp();print "<th>$text{$_}</th>";}
print "<th>$text{'action'}</th></tr>";
foreach my $m (sort @machine){
  print "<form method=post action='clientadmin.cgi'>";
  print "<tr>";
  chomp($m);
  foreach my $c (@col){
    chomp($c);
    print "<td>";
    my $command="cipux_get_value -e '$c' -m '$m'";
    &log($SCRIPT,"CMD '$command'");
    # have to calculate if there is a master
    if($c eq "cipuxMaster"){
      &log($SCRIPT,"calculate cipuxMaster");
      foreach(@output){
        $only_one_cipux_master = 1 if $_ eq 'TRUE';
      }
    }
    my @output = `$command`;
    if($output[0]=~m/ERROR/){
      foreach (@output){
        push(@error,$_);
      }
      $error=1;
    }else{
      chomp($output[0]);
      if($c eq 'cipuxRoomName'){
        $client_room=$output[0];
        print $client_room;
# INDEX KEY not editabel ?
#        print "<select name='cipuxRoomName' size=1>";
#        foreach (sort @room){
#          chomp();
#          if($_ eq $output[0]){
#            $client_room=$_;
#            print "<option value='$_' selected>$_</option>";
#          }else{
#            print "<option value='$_'>$_</option>";
#          }
#        }
#        print "</select>";
      }elsif($c eq 'cipuxMaster'){
        print "<select name='cipuxMaster' size=1>";
        if($output[0] eq "TRUE"){
          print "<option value='FALSE'>FALSE</option>";
          print "<option value='TRUE' selected>TRUE</option>";
          &log($SCRIPT,"master TRUE");
        }else{
          if($only_one_cipux_master ==1){
            # we should give only one client the change to be master
            # to avoid data interference
            # if already on is master the other should not get master
            # but if a second master was set by command line tools it
            # should shown here! (respective after if($output[0] eq "TRUE"))
            &log($SCRIPT,"master FALSE, has been an other master");
            print "<option value='FALSE' selected>FALSE</option>";
          }else{
            &log($SCRIPT,"master FALSE, has NOT been an other master");
            print "<option value='FALSE' selected>FALSE</option>";
            print "<option value='TRUE'>TRUE</option>";
          }
        }
        print "</select>";
      }elsif($c eq 'cipuxMacAddress'){
        print "<input type=text maxlength='17' name='cipuxMacAddress' ";
        print "size='17' value='$output[0]'>";
      }elsif($c eq 'cipuxImage'){
        print "<select name='cipuxImage' size=1>";
        foreach my $i (sort keys %image){
          chomp($i);
          if($i eq $output[0]){
            print "<option value='$i' selected>$i</option>";
            #$client_imagen=$i;
          }else{
            print "<option value='$i'>$i</option>";
          }
        }
        print "</select>";
      }elsif($c eq 'cipuxClientNumber'){
         $client_number=$output[0];
         print $client_number;
         #print "($client_room)";
         $number{$client_room}{$client_number}=1;
# INDEX KEY not editabel ?
#        print "<select name='cipuxClientNumber' size=1>";
#        foreach(@number){
#          if($_ eq $output[0]){
#            print "<option value='$_' selected>$_</option>";
#            $number{$output[0]}=1;# rem if nr exists
#            $client_number=$_;
#          }else{
#            print "<option value='$_'>$_</option>";
#          }
#        }
#        print "</select>"

      }elsif($c eq 'cipuxImageSlotNumber'){
        print "<select name='cipuxImageSlotNumber' size=1>";
        foreach my $i (sort keys %image_slot_name){
          chomp($i);
          if($i eq $output[0]){
            print "<option value='$i' selected>$i [$image_slot_name{$i}]</option>";
        #    $client_imagen=$i;
          }else{
            print "<option value='$i'>$i [$image_slot_name{$i}]</option>";
          }
        }
        print "</select>";
      }elsif($c eq 'cipuxHardwareTypeNumber'){
        print "$output[0] [$hardware_type_name{$output[0]}]";
      }else{

        print $output[0];
      }
    }
    print "</td>";
  }
  print "<td>";
  print " <input type=hidden name='machine' ";
  print " value='".$ldap{CipUX}{CipUX_Client_Name_Prefix}."_".$client_room."_".$client_number."'>";
  print " <input type=submit value='$text{'apply'}' name='change'> ";
  print " <input type=submit value='$text{'delete'}' name='delete'> ";
  print "</td>";
  print "</tr>";
  print "</form>\n";
}
print "</table>";
print "<br>";

if($my_error){
  print "<hr noshade>";
  foreach (@my_error){
    print "ERROR $_ <br>";
  }
}

#
print "<h2>$text{'clientadmin_new_client'}:</h2>";

foreach my $room (sort @room){
chomp($room);
print "<h3>$room:</h3>";
print "<table border=0 cellpadding=10 cellspacing=10><tr><td>";
print "<form method=post action='clientadmin.cgi'>";
print "<table border=1>";
foreach (@col){
  chomp();
  print "<tr><th $tb>$text{$_}</th><td>";
  if($_ eq 'cipuxRoomName'){
    print $room;
    print "<input type=hidden name='$_' value='$room'>";

    #print "<select name='cipuxRoomName' size=1>";
    #foreach (sort @room){
    # print "<option value='$room'>$room</option>";

    #}
    #print "</select>";
  }
  if($_ eq 'cipuxClientNumber'){
    print "<select name='cipuxClientNumber' size=1>";
    foreach(@number){
      if(not $number{$room}{$_}){
        if($_ eq $number[0]){
          print "<option value='$_' selected>$_</option>";
        }else{
          print "<option value='$_'>$_</option>";
        }
      }
    }
    print "</select>"
  }
  if ($_ eq 'cipuxMacAddress'){
    print "<input type=text maxlength='17' name='cipuxMacAddress' ";
    print "size='17' value='00:00:00:00:00:00'>";
  }
  if($_ eq 'cipuxMaster'){
    print "<select name='cipuxMaster' size=1>";
    print "<option value='FALSE' selected>FALSE</option>";
    print "<option value='TRUE'>TRUE</option>";
    print "</select>";
  }
  if($_ eq 'cipuxImageSlotNumber'){
    print "<select name='cipuxImageSlotNumber' size=1>";
    foreach my $i (@image){
      chomp($i);
      if($i eq '001'){
        print "<option value='$i' selected>$i [$image_slot_name{$i}]</option>";
      }elsif($i <= $ldap{CipUX}{'Cibot_Hal_Image_Slot_Max'} ){
        print "<option value='$i'>$i [$image_slot_name{$i}]</option>";
      }
    }
    print "</select>";
  }
  if($_ eq 'cipuxHardwareTypeNumber'){
    print "<select name='cipuxHardwareTypeNumber' size=1>";
    # TODO: hardwaretype ist not right parsed, elimenate double numbers!
    foreach my $i (@hardwaretype){
      chomp($i);
      if($i eq '001'){
        print "<option value='$i' selected>$i [$hardware_type_name{$i}]</option>";
      }elsif($i <= $ldap{CipUX}{'Cibot_Hal_Hardware_Type_Max'}){
        print "<option value='$i'>$i [$hardware_type_name{$i}]</option>";
      }
    }
    print "</select>";
  }
  print "</td></tr>";

}
print "</table>";
print "<br>";
print " <input type=submit value='$text{'apply'}' name='apply' >";
print "</form>";
print "</td><td>";

print "<table width=60% cellpadding=5 cellspacing=5 border=0 $cb><tr $cb><td><font color=$explain>$text{'clientadmin_hint'}</font></td></tr></table>";
print "</td></tr></table>";
}

# +=======================================================================+
# || Footer                                                              ||
# +=======================================================================+

&cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});

exit(0);

# +========================================================================+
$PART=              "Subroutines";#                                        |
# +========================================================================+

=pod

=head1 FUNCTIONS

=cut

sub update_dhcpd{

  # for normal cipux
  #my $cmd="/usr/local/cipux/cibot/bin/dhcpd_bot.pl -t -a -n -f /etc/cipux/dhcpd/dhcpd.conf";
  # for suse
  my $cmd="/usr/local/cipux/cibot/bin/dhcpd_bot.pl -c -s -f /etc/cipux/dhcpd/cipux_subclass.conf";
  print "ca CMD: '$cmd<br>";
  my @out=`$cmd`;
  print @out;
  $cmd="/usr/local/cipux/cibot/bin/image_bot.pl";
  print "CMD: '$cmd<br>";
  @out=`$cmd`;
  print  @out;
  $cmd="/usr/local/cipux/cibot/bin/deploy_conf_bot.pl";
  print "CMD: '$cmd<br>";
  @out=`$cmd`;
  print  @out;
  $cmd="/etc/rc.d/init.d/dhcpd restart";
  print "ca CMD: '$cmd<br>";
  @out=`$cmd`;
  print  @out;

}

