#!/usr/bin/perl
# +========================================================================+
# || cat Cip-Pool Administration Tool                                     ||
# || webmin Modul: documentation.cgi                                      ||
# ||                                                                      ||
# || (c) 2001 Christian Kuelker                                           ||
# || License: GPL                                                         ||
# +========================================================================+

package documentation_cgi;

do '../web-lib.pl';
&init_config();

use CipUX::CiBot;
use CipUX::Cat;

my $BRAND   = "cipworx";
my $PROJECT = "cipux";
my $SCRIPT  = "documentation.cgi";
my $dialog = 0;

&log($SCRIPT,"="x76);

# +=======================================================================+
# || check if the LDAP is there                                          ||
# +=======================================================================+
if($cibot_ldap_status eq 'offline'){
  &cat_header($remote_user,\&header,\&help_search_link,\&text);
  print &cat_error(&text('_error_no_ldap_connect'));
  exit(0);
}

my ($result,$role) = &cibot_acl($SCRIPT,$remote_user);
&cat_header($remote_user,\&header,\&help_search_link,\&text);

# hostname, user, arrayref
print &cat_status_line(&get_system_hostname(),
                       "$remote_user ($role) -> $result",
		       [
			&text('server'),
			&text('status'),
			$cipux{Customer},
			&text('date'),
			&text('version'),
                        $ldap{CipUX}{CipUX_Institution_Name}
		       ]
		      );

# +=======================================================================+
# ||  CAT ACL check                                                      ||
# +=======================================================================+
if($result ne 'ok'){
  print "<h1>".&text('access_denied')."</h1>";
  my $error = &text('access_denied_explanation',
                   "<b>$remote_user</b>",
                   "<b>$role</b>");
  &log($SCRIPT,$error);
  print &cat_error($error);
  &cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});
  exit(0)
}

# +======================================================================+
# || Environment                                                         ||
# +=======================================================================+
&log($SCRIPT,"- ReadParse...");
ReadParse();# webmin

# +========================================================================+
# ||  Main                                                                ||
# +========================================================================+

my $dir = `pwd`;
chomp($dir);

my @doc = `cd $dir/doc && ls -1`;
print "<ul>";
foreach my $doc (sort @doc){
  chomp($doc);
  my $size = `cd $dir/doc/ && du -h $doc`;
  chomp($size);
  $size =~ s/$doc//g;
  print "<li><a href='/cat/doc/$doc'>$doc</a> ($size)</li>";
}
print "<ul>";


# +========================================================================+
# ||  Footer                                                              ||
# +========================================================================+

&cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});

exit(0);
