#!/usr/bin/perl
# +========================================================================+
# || CAT CipUX Adminstration Tool                                         ||
# || Webmin module: hardwareadmin.cgi                                     ||
# || Register Computer Clients                                            ||
# || (c) 2001,2002,2003,2005 Christian Kuelker                            ||
# || License: GPL version 2 or later                                      ||
# +========================================================================+

package hardwareadmin_cgi;

do '../web-lib.pl';
&init_config();

use CipUX::CiBot;
use CipUX::Conversion;
use CipUX::Cat;
use CipUX::Task;

my $BRAND   = "cipworx";
my $PROJECT = "cipux";
my $SCRIPT  = "hardwareadmin.cgi";

#my $PART    = "Global";
#my $BUILD   = "2.0-2-Mon May 10 23:38:53 CEST 2004;";
my $DEBUG   = 1;
#my $explain = "#1a9102";
#my $red     = "#ff0000";
#my $blue    = "#0000ff";
#my $green   = "#136302";
#my $warning = "#ee2222";

&log($SCRIPT,"="x76);

# +=======================================================================+
# || check if the LDAP is there                                          ||
# +=======================================================================+
if($cibot_ldap_status eq 'offline'){
  &cat_header($remote_user,\&header,\&help_search_link,\&text);
  print &cat_error(&text('_error_no_ldap_connect'));
  exit(0);
}

&cibot_get_ldap_config();

my ($result,$role) = &cibot_acl($SCRIPT,$remote_user);
&cat_header($remote_user,\&header,\&help_search_link,\&text);

# hostname, user, arrayref
print &cat_status_line(&get_system_hostname(),
                       "$remote_user ($role) -> $result",
		       [
			&text('server'),
			&text('status'),
			$cipux{Customer},
			&text('date'),
			&text('version'),
                        $ldap{CipUX}{CipUX_Institution_Name}
		       ]
		      );

# +=======================================================================+
# ||  CAT ACL check                                                      ||
# +=======================================================================+
if($result ne 'ok'){
  print "<h1>".&text('access_denied')."</h1>";
  my $error = &text('access_denied_explanation',
                   "<b>$remote_user</b>",
                   "<b>$role</b>");
  &log($SCRIPT,$error);
  print &cat_error($error);
  &cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});
  exit(0)
}

# +=======================================================================+
# || Environment                                                         ||
# +=======================================================================+
&log($SCRIPT,"- ReadParse...");
ReadParse();# webmin

my $action    = $in{'action'} if defined($in{'action'});# action
&log($SCRIPT,"- \$action = [$action]");

foreach(sort keys %in){
  &log($SCRIPT,"- IN: [$_] = [$in{$_}]") if defined($in{$_});
}


#my $BRAND   = "cipworx";
#my $PROJECT = "cipux";
#my $SCRIPT  = "hardwareadmin.cgi";
#my $PART    = "Global";
#my $BUILD   = "2.0-2-Mon May 10 23:38:53 CEST 2004;";
#my $DEBUG   = 0;
#my $explain = "#1a9102";
#my $red     = "#ff0000";
#my $blue    = "#0000ff";
#my $green   = "#136302";
#my $warning = "#ee2222";
#my $explain = "#1a9102";

# +=======================================================================+
# || Prepare                                                             ||
# +=======================================================================+

#my $cipux_href = &read_ldap_conf_obj('cipux');
#my $cibot_href = &read_ldap_conf_obj('cibot');
&log($SCRIPT,"Hardware_Type_Max  = ($ldap{CipUX}{CipUX_Hal_Hardware_Type_Max})");
&log($SCRIPT,"Hardware_Type_Nics = ($ldap{CipUX}{CipUX_Hal_Hardware_Type_Nics})");
my @number = ('001' .. $ldap{CipUX}{CipUX_Hal_Hardware_Type_Max});
my @nic = split(" ",$ldap{CipUX}{CipUX_Hal_Hardware_Type_Nics});

my @col = qw(
             cn
             cipuxHardwareTypeName
            );

my %maxlength = ();
$maxlength{'cn'} = 3;
$maxlength{'cipuxHardwareTypeName'} = 128;
$maxlength{'cipuxHardwareTypeNic'} = 128;
$maxlength{'cipuxRemark'} = 255;
$maxlength{'cipuxHardwareTypeEnabled'} = 5;

$quatity=0;

# +=======================================================================+
# || Main                                                                ||
# +=======================================================================+

my $changes=0;

# .-----------------------------------------------------------------------.
# | Apply changes to one hardware type                                    |
# .-----------------------------------------------------------------------.
if(defined($in{'apply'})){
  my $values="";
  &log($SCRIPT,"-------------------------------------------------------------");
  &log($SCRIPT,"Action APPLY");
  $changes=1;
  # IN: (cipuxHardwareTypeName): 'Linux_Thin_Client'
  # IN: (cipuxRemark): 'Image for IBM Thin Clients'
  # IN: (apply): 'Eingabe'
  # IN: (cn): '001'
  foreach (@col){
    if($_ ne 'cn'){
      my $cmd = "cipux_set_value "
              . " -v '$in{$_}' -e '$_' -t '$in{'cn'}'";
      &log($SCRIPT,"CMD($cmd)");
      my @output = `$cmd`;
      foreach (@output){
        &log($SCRIPT,"ERROR: '$_'");
      }
    }
  }
  &log($SCRIPT,"-------------------------------------------------------------");
}
# .-----------------------------------------------------------------------.
# | Delete Hardware Type                                                  |
# .-----------------------------------------------------------------------.
if(defined($in{'delete'})){
  &log($SCRIPT,"-------------------------------------------------------------");
  &log($SCRIPT,"Action DELETE");
  $changes=1;
  if(defined($$cipux_href{'cipux_feature_hal_hardware_type_new'})){
    if($$cipux_href{'cipux_feature_hal_hardware_type_new'}){
      &log($SCRIPT,"cipux_feature_hal_hardware_type_new");
      my $cmd = "cipux_del -t '$in{'cn'}'";
      &log($SCRIPT,"CMD($cmd)");
      my $out = `$cmd`;
      &log($SCRIPT,"OUT:$out") if defined $out;
    }
  }
  &log($SCRIPT,"-------------------------------------------------------------");
}

# .-----------------------------------------------------------------------.
# | Add Hardware Type                                                     |
# .-----------------------------------------------------------------------.
$PART="add hardware_type";
if(defined($in{'new'})){
  &log($SCRIPT,"-------------------------------------------------------------");
  &log($SCRIPT,"Action NEW");
  $changes=1;
  if(defined($$cipux_href{'cipux_feature_hal_hardware_type_new'})){
      &log($SCRIPT,"$PART: cipux_feature_hal_hardware_type_new");
    if($$cipux_href{'cipux_feature_hal_hardware_type_new'}){
      my $cmd = "cipux_add";
      foreach(@col){
        if($_ eq 'cn'){
          $cmd .= " -t --attribute cn='$in{'cn'}'";
        }else{
          $cmd .= " --attribute $_='$in{$_}'";
        }
      }
      &log($SCRIPT,"$PART: \$cmd [$cmd]");
      my @out = `$cmd`;
      if($DEBUG){foreach(@out){chomp();&log($SCRIPT,"$out: $_")}}
    }
  }
  &log($SCRIPT,"-------------------------------------------------------------");
}
# .-----------------------------------------------------------------------.
# | Get Data                                                              |
# .-----------------------------------------------------------------------.
foreach my $attribute (@col){
  my $cmd = "cipux_get_value -e '$attribute' -T";
  my @output = `$cmd`;
  if($DEBUG){
    &log($SCRIPT,"\$cmd [$cmd]");
    &log($SCRIPT,"\$attribute '$attribute'");
    foreach (@output){
      chomp();
      &log($SCRIPT,"\$output[] '$_'");
    }
  }
  foreach (@output){
    chomp();
    my($cn,$value)=split("\t",$_,2);
    my $string = '$'.$attribute."{'".$cn."'}='".$value."'";
    &log($SCRIPT,"\$string '$string'");
    eval("$string");
  }
}

# .-----------------------------------------------------------------------.
# | Hardware Type list                                                    |
# .-----------------------------------------------------------------------.

print "<h1>$text{'hardwareadmin_title'}</h2>";
print "<table border=1>";

if($changes){
 my $cmd = "cipux_bot_deploy_conf";
 &log($SCRIPT,"CMD [$cmd]");
 #my @out = `$cmd`;
}

# print table header
print "<tr $tb>";
foreach my $attribute (@col){
 print "<th>$text{$attribute}</th>";
}
print "<th $tb>$text{'action'}</th>";
print "</tr>";

# print table body
foreach my $hardware_type (sort keys %cn){
  $quantity++;
  print "<form method=post action='hardwareadmin.cgi'>";
  print "<tr>";
  foreach  my $attribute (@col){
    # $cipuxImageName{$cn}
    my $string = '$'.$attribute."{'".$hardware_type."'}";
    my $size="size='30'";
    if($attribute eq "cn"){
      print "<td $cb>";
      print eval("$string")."</td>";
    }elsif($attribute eq 'cipuxHardwareTypeNic'){
      print "<td>";
      print "<select name='cipuxHardwareTypeNic' size=1>";
      foreach(@nic){
        if($_ eq eval("$string")){
          print "<option value='$_' selected>$_</option>";
        }else{
          print "<option value='$_'>$_</option>";
        }
      }
      print "</select>"
    }else{
      print "<td>";
      if(!defined($maxlength{$attribute})){
        &log($SCRIPT,"WARNING NO maxlength for $attribute, check @col, %maxlength!");
        $maxlength{$attribute}="";
      }else{
        if(30 > $maxlength{$attribute}){
          $size="size='$maxlength{$attribute}'";
        }
      }
      print "<input type=text $maxlength{$attribute} name='$attribute' ";
      print "size='30' value='".eval("$string")."'>";
      print "</td>";
    }
  }
  print "<td $cb>";
  print " <input type=hidden value='$hardware_type' name='cn'>";
  print " <input type=submit value='$text{'apply'}' name='apply' >";
  if(defined($$cipux_href{'cipux_feature_hal_hardware_type_new'})){
    if($$cipux_href{'cipux_feature_hal_hardware_type_new'}){
      print " <input type=submit value='$text{'delete'}' name='delete' >";
    }
  }
  print "</td>";
  print "</tr>";
  print "</form>";
}
print "</table>";

if(defined($$cipux_href{'cipux_feature_hal_hardware_type_new'})){
  if($$cipux_href{'cipux_feature_hal_hardware_type_new'}){
    if($quantity < $ldap{CipUX}{CipUX_Hal_Hardware_Type_Max}){
      print "<h2>$text{'hardwareadmin_new_hardware_type'}</h2>\n";
      print "<form method=post action='hardwareadmin.cgi'>";
      print "<table border=1>";
      foreach my $attribute (@col){
        print "<tr><th $tb>$text{$attribute}</th><td>";
        if($attribute eq 'cn'){
          print "<select name='cn' size=1>";
          foreach(@number){
            if(not $cn{$_}){
             if($_ eq $number[0]){
               print "<option value='$_' selected>$_</option>";
             }else{
               print "<option value='$_'>$_</option>";
             }
            }
          }
          print "</select>"
        }elsif($attribute eq 'cipuxHardwareTypeNic'){
          print "<select name='cipuxHardwareTypeNic' size=1>";
          foreach(@nic){
            if($_ eq $nic[0]){
              print "<option value='$_' selected>$_</option>";
            }else{
              print "<option value='$_'>$_</option>";
            }
          }
          print "</select>"
        }else{
          print "<input type=text $maxlength{$attribute} name='$attribute' ";
          print "</td></tr>";
        }
      }
      print "</table>";
      print " <input type=submit value='$text{'new'}' name='new' >";

      print "</form>";
    }
  }else{
    &log($SCRIPT,"max image slot reached! no new image slot dialog!");
  }
}

# only for nic feature
#print "<br><table width=40% cellpadding=5 cellspacing=5 border=0 $cb><tr $cb><td><font color=$explain>$text{'hardwareadmin_hint'}</font></td></tr></table>";
#print "</td></tr></table>";

# +=======================================================================+
# || Footer                                                              ||
# +=======================================================================+

&cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});

exit(0);


# +========================================================================+
$PART=              "Subroutines";#                                        |
# +========================================================================+


sub update_dhcpd{

  my $cmd="/usr/local/cipux/cibot/bin/dhcpd_bot.pl -f /etc/cipux/dhcpd/dhcpd.conf";
  print "CMD: '$cmd<br>";
  # if file exists we should update, but if not we have to relay on the bot
  if(-e "/usr/local/cipux/cibot/bin/dhcpd_bot.pl"){
    my @out=`$cmd`;
    print @out;
    $cmd="/etc/rc.d/init.d/dhcpd restart";
    print "CMD: '$cmd<br>";
    @out=`$cmd`;
    print  @out;
  }
}
