#!/usr/bin/perl
# +========================================================================+
# || CAT CipUX Adminstration Tool                                         ||
# || Webmin module: imageadmin.cgi                                        ||
# || Register Computer Clients                                            ||
# || (c) 2001,2002,2003,2005 Christian Kuelker                            ||
# || License: GPL version 2 or later                                      ||
# +========================================================================+

package imageadmin_cgi;

do '../web-lib.pl';
&init_config();

use CipUX::CiBot;
use CipUX::Conversion;
use CipUX::Cat;
use CipUX::Task;

my $BRAND   = "cipworx";
my $PROJECT = "cipux";
my $SCRIPT  = "imageadmin.cgi";

#my $PART    = "Global";
#my $BUILD   = "2.0-2-Mon May 10 23:38:53 CEST 2004;";
#my $DEBUG   = 0;
#my $explain = "#1a9102";
#my $red     = "#ff0000";
#my $blue    = "#0000ff";
#my $green   = "#136302";
#my $warning = "#ee2222";

&log($SCRIPT,"="x76);

# +=======================================================================+
# || check if the LDAP is there                                          ||
# +=======================================================================+
if($cibot_ldap_status eq 'offline'){
  &cat_header($remote_user,\&header,\&help_search_link,\&text);
  print &cat_error(&text('_error_no_ldap_connect'));
  exit(0);
}

&cibot_get_ldap_config();

my ($result,$role) = &cibot_acl($SCRIPT,$remote_user);
&cat_header($remote_user,\&header,\&help_search_link,\&text);

# hostname, user, arrayref
print &cat_status_line(&get_system_hostname(),
                       "$remote_user ($role) -> $result",
		       [
			&text('server'),
			&text('status'),
			$cipux{Customer},
			&text('date'),
			&text('version'),
                        $ldap{CipUX}{CipUX_Institution_Name}
		       ]
		      );

# +=======================================================================+
# ||  CAT ACL check                                                      ||
# +=======================================================================+
if($result ne 'ok'){
  print "<h1>".&text('access_denied')."</h1>";
  my $error = &text('access_denied_explanation',
                   "<b>$remote_user</b>",
                   "<b>$role</b>");
  &log($SCRIPT,$error);
  print &cat_error($error);
  &cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});
  exit(0)
}

# +=======================================================================+
# || Environment                                                         ||
# +=======================================================================+
&log($SCRIPT,"- ReadParse...");
ReadParse();# webmin

my $action    = $in{'action'} if defined($in{'action'});# action
&log($SCRIPT,"- \$action = [$action]");

foreach(sort keys %in){
  &log($SCRIPT,"- IN: [$_] = [$in{$_}]") if defined($in{$_});
}


#y $BRAND   = "cipworx";
#y $PROJECT = "cipux";
#my $SCRIPT  = "imageadmin.cgi";
#my $PART    = "Global";
#my $BUILD   = "2.0-2-Mon May 10 23:38:53 CEST 2004;";
#my $DEBUG   = 0;
#my $VERBOSE = 0;
#my $explain = "#1a9102";
#my $red     = "#ff0000";
#my $blue    = "#0000ff";
#my $green   = "#136302";
#my $warning = "#ee2222";

# +=======================================================================+
# || Prepare                                                             ||
# +=======================================================================+

#my $cipux_href = &read_ldap_conf_obj('cipux');
#my $cibot_href = &read_ldap_conf_obj('cibot');
&log($SCRIPT,"Image_Slot_Max  = ($ldap{CipUX}{CipUX_Hal_Image_Slot_Max})");
my @number = ('001' .. $ldap{CipUX}{CipUX_Hal_Image_Slot_Max});

my @col = qw(
             cn
             cipuxImageSlotName
             cipuxImageSlotProtect
            );

my %maxlength = ();
$maxlength{'cn'} = 3;
$maxlength{'cipuxImageSlotName'} = 128;
$maxlength{'cipuxRemark'} = 255;
$maxlength{'cipuxImageSlotEnabled'} = 5;
$maxlength{'cipuxImageSlotProtect'} = 5;

my %truth=();
$truth{TRUE}=$text{TRUE};
$truth{FALSE}=$text{FALSE};

my $quantity=0;

# +=======================================================================+
# || Main                                                                ||
# +=======================================================================+

my $changes=0;

# .-----------------------------------------------------------------------.
# | Apply changes to one image slot                                       |
# .-----------------------------------------------------------------------.
if(defined($in{'apply'})){
  my $values="";
  $changes=1;
  &log($SCRIPT,"-------------------------------------------------------------");
  &log($SCRIPT,"Action APPLY");
  # IN: (cipuxImageSlotName): 'Linux_Thin_Client'
  # IN: (cipuxRemark): 'Image for IBM Thin Clients'
  # IN: (apply): 'Eingabe'
  # IN: (cn): '001'
  foreach (@col){
    if($_ ne 'cn'){
      my $cmd = "cipux_set_value "
              . " -v '$in{$_}' -e '$_' -s '$in{'cn'}'";
      &log($SCRIPT,"apply: \$cmd [$cmd]");
      my @output = `$cmd`;
      foreach (@output){
        &log($SCRIPT,"ERROR: '$_'");
        my @out = `$cmd`;
      }
    }
  }
  &log($SCRIPT,"-------------------------------------------------------------");
}
# .-----------------------------------------------------------------------.
# | Delete Image Slot                                                     |
# .-----------------------------------------------------------------------.
if(defined($in{'delete'})){
  &log($SCRIPT,"-------------------------------------------------------------");
  &log($SCRIPT,"Action DELETE");
  $changes=1;
  if(defined($$cipux_href{'cipux_feature_hal_image_slot_new'})){
    if($$cipux_href{'cipux_feature_hal_image_slot_new'}){
      &log($SCRIPT,"delete cipux_feature_hal_image_slot_new");
      my $cmd = "cipux_del -s '$in{'cn'}'";
      &log($SCRIPT,"CMD($cmd)");
      my $out = `$cmd`;
      &log($SCRIPT,"OUT:$out") if defined $out;
    }
  }
  &log($SCRIPT,"-------------------------------------------------------------");
}

# .-----------------------------------------------------------------------.
# | Add Image Slot                                                        |
# .-----------------------------------------------------------------------.
$PART="add slot";
if(defined($in{'new'})){
  &log($SCRIPT,"-------------------------------------------------------------");
  &log($SCRIPT,"Action NEW");
  $changes=1;
  if(defined($$cipux_href{'cipux_feature_hal_image_slot_new'})){
    &log($SCRIPT,"$PART: cipux_feature_hal_image_slot_new");
    if($$cipux_href{'cipux_feature_hal_image_slot_new'}){
      my $cmd = "cipux_add";
      foreach(@col){
        if($_ eq 'cn'){
          $cmd .= " -s --attribute cn='$in{'cn'}'";
        }else{
          $cmd .= " --attribute $_='$in{$_}'";
        }
      }
      &log($SCRIPT,"CMD($cmd)");
      my @out = `$cmd`;
      if($DEBUG){foreach(@out){chomp();&log($SCRIPT,"$out: $_")}}
    }
  }
  &log($SCRIPT,"-------------------------------------------------------------");
}
# .-----------------------------------------------------------------------.
# | Get Data                                                              |
# .-----------------------------------------------------------------------.
foreach my $attribute (@col){
  my $cmd = "cipux_get_value -e '$attribute' -S";
  my @output = `$cmd`;
  if($DEBUG){
    &log($SCRIPT,"\$cmd [$cmd]");
    &log($SCRIPT,"\$attribute '$attribute'");
    foreach (@output){
      chomp();
      &log($SCRIPT,"\$output[] '$_'");
    }
  }
  foreach (@output){
    chomp();
    my($cn,$value)=split("\t",$_,2);
    my $string = '$'.$attribute."{'".$cn."'}='".$value."'";
    &log($SCRIPT,"\$string '$string'");
    eval("$string");
  }
}

# .-----------------------------------------------------------------------.
# | Slot list                                                            |
# .-----------------------------------------------------------------------.

print "<h1>$text{'imageadmin_title'}</h2>";
print "<table border=1>";

if($changes){
 my $cmd = "/usr/local/cipux/cibot/bin/deploy_conf_bot.pl";
 &log($SCRIPT,"CMD [$cmd]");
 #my @out = `$cmd`;
}

# print table header
print "<tr $tb>";
foreach my $attribute (@col){
 chomp($attribute);
 if($attribute ne "cipuxImageSlotProtect"){
   print "<th>$text{$attribute}</th>";
 }elsif($remote_user eq "root"){
   print "<th>$text{$attribute}</th>";
 }
}
print "<th $tb>$text{'action'}</th>";
print "</tr>";

# print table body
foreach my $image_slot (sort keys %cn){
  $quantity++;
  print "<form method=post action='imageadmin.cgi'>";
  print "<tr>";
  foreach  my $attribute (@col){
    # $cipuxImageName{$cn}
    my $string = '$'.$attribute."{'".$image_slot."'}";
    my $size="size='30'";
    if($attribute eq "cn"){
      print "<td $cb>";
      print eval("$string")."</td>\n";
    }elsif($attribute eq "cipuxImageSlotProtect" and $remote_user eq "root"){
      print "<td>";
      print "<select name='cipuxImageSlotProtect' size=1>";
      foreach(sort keys %truth){
        if(eval("$string") eq $_ ){
          print "<option value='$_' selected>$truth{$_}</option>";
        }else{
          print "<option value='$_'>$truth{$_}</option>";
        }
      }
      print "</select>";
      print "</td>\n";
    }elsif($attribute ne "cipuxImageSlotProtect"){# the rest!
      print "<td>";
      if(!defined($maxlength{$attribute})){
        &log($SCRIPT,"WARNING NO maxlength for $attribute, check @col, %maxlength!");
        $maxlength{$attribute}="";
      }else{
        if(30 > $maxlength{$attribute}){
          $size="size='$maxlength{$attribute}'";
        }
      }
      print "<input type=text $maxlength{$attribute} name='$attribute' ";
      print "size='30' value='".eval("$string")."'>";
      print "</td>\n";
    }
  }
  print "<td $cb>";
  print " <input type=hidden value='$image_slot' name='cn'>";
  print " <input type=submit value='$text{'apply'}' name='apply' >";
  if(defined($$cipux_href{'cipux_feature_hal_image_slot_new'})){
    if($$cipux_href{'cipux_feature_hal_image_slot_new'}){

      print " <input type=submit value='$text{'delete'}' name='delete' >";
    }
  }
  print "</td>";
  print "</tr>";
  print "</form>";
}
print "</table>";

if(defined($$cipux_href{'cipux_feature_hal_image_slot_new'})){
  if($$cipux_href{'cipux_feature_hal_image_slot_new'}){
    if($quantity < $ldap{CipUX}{CipUX_Hal_Image_Slot_Max}){
      print "<h2>$text{'imageadmin_new_image_slot'}</h2>\n";
      print "<form method=post action='imageadmin.cgi'>";
      print "<table border=1>";
      foreach my $attribute (@col){
        print "<tr><td $tb>$text{$attribute}</td><td>";
        if($attribute eq 'cn'){
          print "<select name='cn' size=1>";
          foreach(@number){
            if(not $cn{$_}){
             if($_ eq $number[0]){
               print "<option value='$_' selected>$_</option>";
             }else{
               print "<option value='$_'>$_</option>";
             }
            }
          }
          print "</select>"
        }else{
          print "<input type=text $maxlength{$attribute} name='$attribute' ";
          print "</td></tr>";
        }
      }
      print "</table>";
      print " <input type=submit value='$text{'new'}' name='new' >";

      print "</form>";
    }
  }else{
    &log($SCRIPT,"max image slot reached! no new image slot dialog!");
  }
}

print "<table width=40% cellpadding=5 cellspacing=5 border=0 $cb><tr $cb><td><font colo
r=$explain>$text{'imageadmin_hint'}</font></td></tr></table>";
print "</td></tr></table>";

# +=======================================================================+
# || Footer                                                              ||
# +=======================================================================+

&cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});

exit(0);


# +========================================================================+
$PART=              "Subroutines";#                                        |
# +========================================================================+

sub update_dhcpd{

  my $cmd="/usr/local/cipux/cibot/bin/dhcpd_bot.pl -f /etc/cipux/dhcpd/dhcpd.conf";
  print "CMD: '$cmd<br>";
  my @out=`$cmd`;
  print @out;
  $cmd="/etc/rc.d/init.d/dhcpd restart";
  print "CMD: '$cmd<br>";
  @out=`$cmd`;
  print  @out;
}

