#!/usr/bin/perl
# +========================================================================+
# || CAT CipUX Adminstration Tool                                         ||
# || Webmin module: imagematrix.cgi                                       ||
# || Register Computer Clients                                            ||
# || (c) 2001,2002,2003,2005 Christian Kuelker                            ||
# || License: GPL version 2 or later                                      ||
# +========================================================================+

package imagematrix_cgi;

do '../web-lib.pl';
&init_config();

use CipUX::CiBot;
use CipUX::Conversion;
use CipUX::Cat;
use CipUX::Task;

my $BRAND   = "cipworx";
my $PROJECT = "cipux";
my $SCRIPT  = "imagematrix.cgi";

#my $PART    = "Global";
#my $BUILD   = "2.0-2-Mon May 10 23:38:53 CEST 2004;";
#my $DEBUG   = 0;
#my $explain = "#1a9102";
#my $red     = "#ff0000";
#my $blue    = "#0000ff";
#my $green   = "#136302";
#my $warning = "#ee2222";

&log($SCRIPT,"="x76);

# +=======================================================================+
# || check if the LDAP is there                                          ||
# +=======================================================================+
if($cibot_ldap_status eq 'offline'){
  &cat_header($remote_user,\&header,\&help_search_link,\&text);
  print &cat_error(&text('_error_no_ldap_connect'));
  exit(0);
}

&cibot_get_ldap_config();

my ($result,$role) = &cibot_acl($SCRIPT,$remote_user);
&cat_header($remote_user,\&header,\&help_search_link,\&text);

# hostname, user, arrayref
print &cat_status_line(&get_system_hostname(),
                       "$remote_user ($role) -> $result",
		       [
			&text('server'),
			&text('status'),
			$cipux{Customer},
			&text('date'),
			&text('version'),
                        $ldap{CipUX}{CipUX_Institution_Name}
		       ]
		      );

# +=======================================================================+
# ||  CAT ACL check                                                      ||
# +=======================================================================+
if($result ne 'ok'){
  print "<h1>".&text('access_denied')."</h1>";
  my $error = &text('access_denied_explanation',
                   "<b>$remote_user</b>",
                   "<b>$role</b>");
  &log($SCRIPT,$error);
  print &cat_error($error);
  &cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});
  exit(0)
}

# +=======================================================================+
# || Environment                                                         ||
# +=======================================================================+
&log($SCRIPT,"- ReadParse...");
ReadParse();# webmin

my $action    = $in{'action'} if defined($in{'action'});# action
&log($SCRIPT,"- \$action = [$action]");

foreach(sort keys %in){
  &log($SCRIPT,"- IN: [$_] = [$in{$_}]") if defined($in{$_});
}



#my $BRAND   = "cipworx";
#my $PROJECT = "cipux";
#my $SCRIPT  = "imagematrix.cgi";
#my $PART    = "Global";
#my $BUILD   = "2.0-2-Mon May 10 23:38:53 CEST 2004;";
#my $DEBUG   = 0;
#my $explain = "#1a9102";
#my $red     = "#ff0000";
#my $blue    = "#0000ff";
#my $green   = "#136302";
#my $warning = "#ee2222";

my $checksum_edit=0;


if(!$$cipux_href{cipux_feature_hal_image_matrix}){
print "<br><hr noshade>CIPUX FEATURE IMAGEMATRIX: $text{'no_feature'}<br><hr noshade><br>";
if($remote_user eq "root" or $remote_user eq "admin" or $remote_user eq "cipadmin"){
  &footer("/cat/","CAT");
}else{
  &footer();
}
exit(0);
}


my @test=`/usr/local/cipux/cibot/bin/list.pl -R`;
if($test[0] =~/ERROR/){
  print "<h1>$text{'_error'}:</h1> <b>$text{'_error_no_ldap_connect'}</b><br>";
  &footer();
  exit(1);
}else{
  print "LDAP connect OK<br>" if $DEBUG;
}

# +=======================================================================+
# || Environment                                                         ||
# +=======================================================================+

ReadParse();
my $action = "$in{'action'}" if defined($in{'action'});
foreach my $key (keys %in){
  &log($SCRIPT,"CGI IN: ($key): '".$in{$key}."'");
  push(@new_member,$in{$key}) if $key=~m/^1_/;#workaround, how parsing: a^@b^@c ?
  if($in{$key} eq ''){
    $error=1;
    print "<font color=#ff0000>$text{'application_error'} (1): $text{$key}</font><br>";
    print "<b>$text{'groupmember_empty_field'}</b><br>";
  }
}

# +=======================================================================+
# || Prepare                                                             ||
# +=======================================================================+

my $cipux_href = &read_ldap_conf_obj('cipux');
my $cibot_href = &read_ldap_conf_obj('cibot');
&log($SCRIPT,"Image_Matrix_Max   = ($$cibot_href{Cibot_Hal_Image_Matrix_Max})");
&log($SCRIPT,"Hardware_Type_Max  = ($$cibot_href{Cibot_Hal_Hardware_Type_Max})");
&log($SCRIPT,"Image_Slot_Max     = ($$cibot_href{Cibot_Hal_Image_Slot_Max})");
my @number = ('001' .. $$cibot_href{Cibot_Hal_Image_Matrix_Max});
my @ht_max = ('001' .. $$cibot_href{Cibot_Hal_Hardware_Type_Max});
my @is_max = ('001' .. $$cibot_href{Cibot_Hal_Image_Slot_Max});
my @boolean = qw(FALSE TRUE);# ordering matters!
my @image_type = split(" ",$$cibot_href{Cibot_Hal_Image_Type_Extension});

#Cibot_Hal_Hardware_Type_Max

my @col = qw(
             cn
             cipuxImageName
             cipuxImageType
             cipuxImageSlotNumber
             cipuxHardwareTypeNumber
             cipuxImageProtect
            );
# META may be cipuxChecksum

my %maxlength = ();
$maxlength{'cn'} = 3;
$maxlength{'cipuxImageName'} = 128;
$maxlength{'cipuxImageType'} = 128;
$maxlength{'cipuxImageSlot'} = 3;
$maxlength{'cipuxHardwareTypeNumber'}= 3;
$maxlength{'cipuxImageSlotNumber'}=3;
$maxlength{'cipuxChecksum'} = 255;
$maxlength{'cipuxRemark'} = 255;
$maxlength{'cipuxImageProtect'} = 1;

my $lacks_occurs = 0;
my $undefined_occurs = 0;
my $free_occurs = 0;

# +=======================================================================+
# || Main                                                                ||
# +=======================================================================+

# .-----------------------------------------------------------------------.
# | Apply changes to one image                                            |
# .-----------------------------------------------------------------------.
if(defined($in{'apply'})){
  my $values="";
  &log($SCRIPT,"-------------------------------------------------------------");
  &log($SCRIPT,"Action APPLY");
  # IN: (cipuxImageMatrixName): 'Linux_Thin_Client'
  # IN: (cipuxRemark): 'Image for IBM Thin Clients'
  # IN: (apply): 'Eingabe'
  # IN: (cn): '001'
  foreach (@col){
#    if($_ ne 'cn'){
      my $cmd = "/usr/local/cipux/cibot/bin/set_value.pl "
              . " -v '$in{$_}' -e '$_' -i '$in{'cn'}'";
      &log($SCRIPT,"DEBUG: \$cmd [$cmd]");
      my @output = `$cmd`;
      foreach (@output){
        &log($SCRIPT,"ERROR: '$_'");
#      }
    }
  }
  &log($SCRIPT,"-------------------------------------------------------------");
}
# .-----------------------------------------------------------------------.
# | Delete Image                                                          |
# .-----------------------------------------------------------------------.
if(defined($in{'delete'})){
  &log($SCRIPT,"-------------------------------------------------------------");
  &log($SCRIPT,"Action DELETE");
  if(defined($$cipux_href{'cipux_feature_hal_image_new'})){
    if($$cipux_href{'cipux_feature_hal_image_new'}){
      &log($SCRIPT,"cipux_feature_hal_image_new");
      my $cmd = "/usr/local/cipux/cibot/bin/del.pl -i '$in{'cn'}'";
      &log($SCRIPT,"CMD($cmd)");
      my $out = `$cmd`;
      print "OUT:$out\n" if defined $out;
    }
  }
  &log($SCRIPT,"-------------------------------------------------------------");
}

# .-----------------------------------------------------------------------.
# | Add Image                                                             |
# .-----------------------------------------------------------------------.
$PART ="add image";
if(defined($in{'new'})){
  &log($SCRIPT,"-------------------------------------------------------------");
  &log($SCRIPT,"Action NEW");
  if(defined($$cipux_href{'cipux_feature_hal_image_new'})){
    &log($SCRIPT,"$PART: cipux_feature_hal_image_new");
    if($$cipux_href{'cipux_feature_hal_image_new'}){
      my $cmd = "/usr/local/cipux/cibot/bin/add.pl";
      foreach(@col){
        if($_ eq 'cn'){
          $cmd .= " -i --attribute cn='$in{'cn'}'";
        }else{
          $cmd .= " --attribute $_='$in{$_}'";
        }
      }
      &log($SCRIPT,"$PART: \$cmd [$cmd]");
      my @out = `$cmd`;
      if($DEBUG){foreach(@out){chomp();&log($SCRIPT,"$out: $_")}}
    }
  }
  &log($SCRIPT,"-------------------------------------------------------------");
}
# .-----------------------------------------------------------------------.
# | Get Data                                                              |
# .-----------------------------------------------------------------------.
if(defined($in{'view_matrix'}) or defined($in{'view_image_list'})){
  foreach my $attribute (@col){
    my $cmd = "/usr/local/cipux/cibot/bin/get_value.pl -e '$attribute' -I";
    my @output = `$cmd`;
    if($DEBUG){
      &log($SCRIPT,"\$cmd [$cmd]");
      &log($SCRIPT,"\$attribute '$attribute'");
      foreach (@output){
        chomp();
        &log($SCRIPT,"\$output[] '$_'");
        my($key,$value)=split("\t");
        $value{$attribute}{$key}=$value;
        &log($SCRIPT,"\$value attribute($attribute)key($key)=>($value)");
      }
    }
    foreach (@output){
      chomp();
      my($cn,$value)=split("\t",$_,2);
      my $string = '$'.$attribute."{'".$cn."'}='".$value."'";
      &log($SCRIPT,"\$string '$string'");
      eval("$string");
    }
  }
}
# | title

#f(defined($in{'view_image_list'}) or defined($in{'view_matrix'})){
#
#else{
# print "<h1>$text{'imagematrix_title'}</h1>";
#


# .-----------------------------------------------------------------------.
# | Nav Bar                                                               |
# .-----------------------------------------------------------------------.

print "<br><table border=0 cellspacing=5 cellpadding=5><tr $cb>\n";

# | View image list                                                     |
if(not defined($in{'view_image_list'})){
  print "<td><form method=post action='imagematrix.cgi'>";
  print "<input type=submit value='$text{'view_image_list'}' name='view_image_list'>";
  print "</form></td>";
}
# | View image matrix                                                     |
if(not defined($in{'view_matrix'})){
  print "<td><form method=post action='imagematrix.cgi'>";
  print "<input type=submit value='$text{'view_matrix'}' name='view_matrix'>";
  print "</form></td>";
}
print "</tr></table>\n";

# .-----------------------------------------------------------------------.
# | View image matrix                                                     |
# .-----------------------------------------------------------------------.
$PART ="view image matrix";
if(defined($in{'view_matrix'})){
  &log($SCRIPT,"$PART: Action VIEW (THE image matrix)=========================");

  print "<h1>$text{'imagematrix_the_matrix'}</h1>";
  print "<h2>$text{'imagematrix_the_matrix2'}</h2>";

  # we collect some additin(al) values
  my %addition=();
  my %value2=();
  # HoH  Perl <283>
  my %object  = (
      list => [qw(cipuxImageSlotNumber cipuxHardwareTypeNumber)],
      image => [qw(cipuxChecksum)],
      machine => [qw(cipuxImageSlotNumber cipuxHardwareTypeNumber)],
      hardwaretype =>[qw(cipuxHardwareTypeName)],
  );
  my %cmd=();
  $cmd{list}{cipuxImageSlotNumber}
      ="/usr/local/cipux/cibot/bin/list.pl -S";
  $cmd{list}{cipuxHardwareTypeNumber}
      ="/usr/local/cipux/cibot/bin/list.pl -T";
  $cmd{image}{cipuxChecksum}
      ="/usr/local/cipux/cibot/bin/get_value.pl -I -e 'cipuxChecksum'";
  $cmd{machine}{cipuxImageSlotNumber}
      ="/usr/local/cipux/cibot/bin/get_value.pl -M -e 'cipuxImageSlotNumber'";
  $cmd{machine}{cipuxHardwareTypeNumber}
      ="/usr/local/cipux/cibot/bin/get_value.pl -M -e 'cipuxHardwareTypeNumber'";
  $cmd{hardwaretype}{cipuxHardwareTypeName}
      ="/usr/local/cipux/cibot/bin/get_value.pl -T -e 'cipuxHardwareTypeName'";

  foreach my $object(keys %object){
    &log($SCRIPT,"1 object: ($object)");
    foreach my $attribute(@{$object{$object}}){
      &log($SCRIPT,"2 attribute: ($attribute)");

      my $cmd = $cmd{$object}{$attribute};
      &log($SCRIPT,"CMD($cmd)");
      $addition{$object}{$attribute}=[`$cmd`];
      foreach my $list (@{$addition{$object}{$attribute}}){
        chomp($list);
        my($key,$value) = "";
        if($list =~ m/\t/){
          ($key,$value) = split("\t",$list);
        }else{
          $value = 1;
          $key = $list;
        }
        $value2{$object}{$attribute}{$key}=$value;
        &log($SCRIPT,"value2($object)($attribute)($key)=>($value)");
      }
    }
  }

  my $in_max='000';# image number
  my %matrix=();
  # calculate the max image number
  foreach(@ht_max){
    foreach(@is_max){
     $in_max++;
    }
  }
  &log($SCRIPT,"in_max($in_max)");
  # set every image in the matrix
  foreach my $i('001'.. $in_max){
    if(defined($value{'cipuxImageSlotNumber'}{$i})and
       defined($value{'cipuxHardwareTypeNumber'}{$i})){
       my $is = $value{'cipuxImageSlotNumber'}{$i};
       my $ht = $value{'cipuxHardwareTypeNumber'}{$i};
       $matrix{$ht}{$is}=$i;
    }
  }
  # calculate the machine (Image Slot hardware type) matrix
  my $c=0;
  foreach (@{$addition{machine}{cipuxHardwareTypeNumber}} ){
   chomp();
   my($key1,$value1)=split("\t");
   my($key2,$value2)=split("\t",$addition{machine}{cipuxImageSlotNumber}[$c]);
   &log($SCRIPT,"machine k1($key1)k2($key2)v1($value1)v2($value2)");
   $machine_matrix{$value1}{$value2}=$key1; # or key2 (the same)
   $c++;
  }

  # print out the matrix table
  print "<table border=0><tr><td>";
  print "<table border=1>";
  print "<tr $cb>";# table head
  #print "<td >x &#092; y</td>";
  print "<th><font color=#ff0000>$text{'image_slot'}:</font></th>";
  foreach my $is_id(@is_max){
      print "<th rowspan=2><font color=#ff0000>$is_id</font></th>";

  }
  print "</tr>";
  print "<tr $cb>";# table head 2
  print "<th><font color=#0000ff>$text{'hardware_type'}:</font></th>";
  print "</tr>";
  foreach my $ht (@ht_max){# process every hardware type
    my $ht_name ="-";
    if(defined($value2{hardwaretype}{cipuxHardwareTypeName}{$ht})){
      $ht_name = $value2{hardwaretype}{cipuxHardwareTypeName}{$ht};
    }
    print "<tr><td $cb><font color=#0000ff><b>$ht</b><br>$ht_name</font></td>";
    foreach my $is(@is_max){# process every image slot
      if(defined($value2{list}{cipuxHardwareTypeNumber}{$ht})and
        defined($value2{list}{cipuxImageSlotNumber}{$is})){
        # hardware type and image slot exists
        if(defined($matrix{$ht}{$is})){# a image exist
          my $i = $matrix{$ht}{$is};
          my $cs = $value2{image}{'cipuxChecksum'}{$i};
          my $p = $value{'cipuxImageProtect'}{$i};
          &log($SCRIPT,"image($i)-x=ht($ht),y=is($is)cs($cs)p($p)");
          # is the image protected or not
          if($value{'cipuxImageProtect'}{$i} eq 'TRUE'){
            print "<td $cb>";
          }else{
            print "<td $tb>";
          }
          # is the image 'virtal' or not
          if($cs ne '0'){
            # image do exist and was created = not virtual
            print "<img src='images/ball.green.png'><br>$i";
          }else{
          # image do exist but was not created = virtual
            print "<img src='images/ball.purple.png'><br>$i";
          }
          print "</td>";
        }elsif(defined($machine_matrix{$ht}{$is})){
          # machine exist, a image should be made
            print "<td><b>$text{'lacks'}</b></td>";
            $lacks_occurs = 1;
        }else{
           print "<td>$text{'free'}</td>";
           $free_occurs = 1;
           &log($SCRIPT,"free ht($ht) is($is)");
        }
      }else{
         print "<td>-</td>";
         $undefined_occurs = 1;
      }
    }
    print "</tr>";
  }
  print "</table></td>";
  print "<td>&nbsp;</td>";# gap between legend
  print "<td><table border=0>";
 print  "<tr><td colspan=2>$text{'legend'}:</td><tr>";
  print "<tr><td><img src='images/ball.purple.png'></td><td> : $text{'imagematrix_legend1'}</td></tr>";
  print "<tr><td><img src='images/ball.green.png'></td><td> : $text{'imagematrix_legend2'}</td></tr>";
  print "<tr><td $cb>&nbsp;</td><td> : $text{'imagematrix_legend3'}</td></tr>";
  print "<tr><td $tb>&nbsp;</td><td> : $text{'imagematrix_legend4'}</td></tr>";
#  print "<tr><td>x</td><td> : $text{'hardware_type'}</td></tr>";
#  print "<tr><td>y</td><td> : $text{'image_slot'}</td></tr>";
  if($undefined_occurs){
    print "<tr><td>-</td><td> : $text{'undefined'}</td></tr>";
  }
  if($free_occurs){
    print "<tr><td>$text{'free'}</td><td> : $text{'imagematrix_legend5'}</td></tr>";
  }
  if($lacks_occurs){
    print "<tr><td><b>$text{'lacks'}</b></td><td> : $text{'imagematrix_legend6'}</td></tr>";
  }
  print "</table>";
  print "</td></tr></table>";
  print "<table>";
  print "<tr><td colspan=2>$text{'imagematrix_hint1'}</td></tr>";
  print "<tr><td colspan=2>$text{'imagematrix_hint2'}</td></tr>";
  if($undefined_occurs){
    print "<tr><td colspan=2>$text{'imagematrix_hint3'}</td></tr>";
  }
  print "</table>";

}

# .-----------------------------------------------------------------------.
# | Image list                                                           |
# .-----------------------------------------------------------------------.
$PART="Image list";

&log($SCRIPT,"$PART=======================================================");

if(defined($in{'view_image_list'})){
  print "<h1>$text{'imagematrix_matrix_list'}</h1>";
  print "<h2>$text{'imagematrix_matrix_list2'}</h2>";
  print "<table border=1>";

  # print table header
  print "<tr $tb>";
  foreach my $attribute (@col){
    print "<th>$text{$attribute}</th>";
  }
  print "<th $tb>$text{'action'}</th>";
  print "</tr>";

  # print table body
  foreach my $image_matrix (sort keys %cn){
    print "<form method=post action='imagematrix.cgi'>";
    print "<tr>";
    my $deletable=0;
    foreach  my $attribute (@col){
      # $cipuxImageName{$cn}
      my $string = '$'.$attribute."{'".$image_matrix."'}";
      my $size="size='30'";
      $deletable=1 if eval("$string") eq 'FALSE'
                      and $attribute eq 'cipuxImageProtect';
      &log($SCRIPT,"$PART \$deletable ($deletable) \$attribute ($attribute)");
      if($attribute eq "cn"){
        print "<td $cb>";
        print eval("$string")."</td>";
      }elsif($attribute eq 'cipuxImageSlotNumber'){
        if($$cipux_href{'cipux_feature_hal_image_slot_move'}){
          print "<td>";
          print "<select name='cipuxImageSlotNumber' size=1>";
          foreach(@is_max){
            if($_ eq eval("$string")){
              print "<option value='$_' selected>$_</option>";
            }else{
              print "<option value='$_'>$_</option>";
            }
          }
          print "</select>"
        }else{
          print "<td $cb>";
          print eval("$string");
        }
      }elsif($attribute eq 'cipuxHardwareTypeNumber'){
        if($$cipux_href{'cipux_feature_hal_hardware_type_move'}){
          print "<td>";
          print "<select name='cipuxHardwareTypeNumber' size=1>";
          foreach(@ht_max){
            if($_ eq eval("$string")){
              print "<option value='$_' selected>$_</option>";
            }else{
              print "<option value='$_'>$_</option>";
            }
          }
          print "</select>"
        }else{
          print "<td $cb>";
          print eval("$string");
        }
      }elsif($attribute eq 'cipuxImageProtect'){
        if($$cipux_href{'cipux_feature_hal_image_protect_editable'}){
          print "<td>";
          print "<select name='cipuxImageProtect' size=1>";
          foreach(@boolean){
            if($_ eq eval("$string")){
              print "<option value='$_' selected>$_</option>";
            }else{
              print "<option value='$_'>$_</option>";
            }
          }
          print "</select>"
        }else{
          print "<td $cb>";
          print eval("$string");
        }
      }elsif($attribute eq 'cipuxImageType'){
        if($$cipux_href{'cipux_feature_hal_image_type_editable'}){
          print "<td>";
          print "<select name='cipuxImageType' size=1>";
          foreach(@image_type){
            if($_ eq eval("$string")){
              print "<option value='$_' selected>$_</option>";
            }else{
              print "<option value='$_'>$_</option>";
            }
          }
          print "</select>"
        }else{
          print "<td $cb>";
          print eval("$string");
        }
      }elsif($attribute eq 'cipuxChecksum'){
        if($checksum_edit){
          print "<td>";
          print "<input type=text $maxlength{$attribute} name='$attribute' ";
          print "$size value='".eval("$string")."'>";
        }else{
          print "<td $cb>";
          print eval("$string");
        }
      }else{
        print "<td>";
        if(!defined($maxlength{$attribute})){
          &log($SCRIPT,"WARNING NO maxlength for $attribute, check @col, %maxlength!");
          $maxlength{$attribute}="";
        }else{
          if(30 > $maxlength{$attribute}){
            $size="size='$maxlength{$attribute}'";
          }
        }
        print "<input type=text $maxlength{$attribute} name='$attribute' ";
        print "$size value='".eval("$string")."'>";
        print "</td>";
      }
    }
    print "<td $cb>";
    print " <input type=hidden value='$image_matrix' name='cn'>";
    print " <input type=submit value='$text{'apply'}' name='apply' >";
    if(defined($$cipux_href{'cipux_feature_hal_image_new'})){
      if($$cipux_href{'cipux_feature_hal_image_new'}){
        if($deletable){
          print " <input type=submit value='$text{'delete'}' name='delete' >";
        }
      }
    }
    print "</td>";
    print "</tr>";
    print "</form>";
  }
  print "</table>";
}

# | New image dialog                                                      |

if(defined($$cipux_href{'cipux_feature_hal_image_new'})
   and defined($in{'view_image_list'})){
  if($$cipux_href{'cipux_feature_hal_image_new'}){
    print "<h2>$text{'imagematrix_new_image_matrix'}</h2>\n";
    print "<form method=post action='imagematrix.cgi'>";
    print "<table border=1>";
    foreach my $attribute (@col){
      print "<tr><td $tb>$text{$attribute}</td><td>";
      if($attribute eq 'cn'){
        print "<select name='cn' size=1>";
        foreach(@number){
          if(not $cn{$_}){
           if($_ eq $number[0]){
             print "<option value='$_' selected>$_</option>";
           }else{
             print "<option value='$_'>$_</option>";
           }
          }
        }
        print "</select>"
      }elsif($attribute eq 'cipuxImageSlotNumber'){
        print "<select name='cipuxImageSlotNumber' size=1>";
        foreach(@is_max){
          if($_ eq $is_max[0]){
            print "<option value='$_' selected>$_</option>";
          }else{
            print "<option value='$_'>$_</option>";
          }
        }
        print "</select>"
      }elsif($attribute eq 'cipuxHardwareTypeNumber'){
        print "<select name='cipuxHardwareTypeNumber' size=1>";
        foreach(@ht_max){
          if($_ eq $ht_max[0]){
            print "<option value='$_' selected>$_</option>";
          }else{
            print "<option value='$_'>$_</option>";
          }
        }
        print "</select>"
      }elsif($attribute eq 'cipuxImageProtect'){
        if($$cipux_href{'cipux_feature_hal_image_protect_editable'}){
          print "<select name='cipuxImageProtect' size=1>";
          foreach(@boolean){
            if($_ eq $boolean[0]){
              print "<option value='$_' selected>$_</option>";
            }else{
              print "<option value='$_'>$_</option>";
            }
          }
          print "</select>"
        }else{
          print $boolean[0];
          print "<input type=hidden name='$attribute' value='FALSE'>";
        }
      }elsif($attribute eq 'cipuxImageType'){
      #  if($$cipux_href{'cipux_feature_hal_image_type_editable'}){
          print "<select name='cipuxImageType' size=1>";
          foreach(@image_type){
            if($_ eq $image_type[0]){
              print "<option value='$_' selected>$_</option>";
            }else{
              print "<option value='$_'>$_</option>";
            }
          }
          print "</select>"
       # }else{
       #   print $image_type[0];
       # }
      }elsif($attribute eq 'cipuxChecksum'){
        if($checksum_edit){
          print "<input type=text $maxlength{$attribute} name='$attribute'>";
        }else{
          print "$text{'empty'}";
        }
      }else{
        print "<input type=text $maxlength{$attribute} name='$attribute'>";
        print "</td></tr>";
      }
    }
    print "</table>";
    print " <input type=submit value='$text{'new'}' name='new' >";

    print "</form>";

  }
}

print "<br><table width=40% cellpadding=5 cellspacing=5 border=0 $cb><tr $cb><td><font color=$explain>$text{'imagematrix_hint'}</font></td></tr></table>";
print "</td></tr></table>";

# +=======================================================================+
# || Footer                                                              ||
# +=======================================================================+

&cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});

exit(0);


# +========================================================================+
$PART=              "Subroutines";#                                        |
# +========================================================================+

sub update_dhcpd{
  my $cmd="/usr/local/cipux/cibot/bin/dhcpd_bot.pl -f /etc/cipux/dhcpd/dhcpd.conf";
  if(-e "/usr/local/cipux/cibot/bin/dhcpd_bot.pl"){
    print "CMD: '$cmd<br>";
    my @out=`$cmd`;
    print @out;
    $cmd="/etc/rc.d/init.d/dhcpd restart";
    print "CMD: '$cmd<br>";
    @out=`$cmd`;
    print  @out;
  }
}
