#!/usr/bin/perl
# +========================================================================+
# || CAT CipUX Adminstration Tool                                         ||
# || Webmin module: rooadmin.cgi                                          ||
# || Register Computer Clients                                            ||
# || (c) 2001,2002,2003,2005 Christian Kuelker                            ||
# || License: GPL version 2 or later                                      ||
# +========================================================================+

package rooadmin_cgi;

do '../web-lib.pl';
&init_config();

use CipUX::CiBot;
use CipUX::Conversion;
use CipUX::Cat;
use CipUX::Task;

my $BRAND   = "cipworx";
my $PROJECT = "cipux";
my $SCRIPT  = "rooadmin.cgi";

#my $PART    = "Global";
#my $BUILD   = "<SE::BUILD>";
#my $DEBUG   = 0;
#my $explain = "#1a9102";
#my $red     = "#ff0000";
#my $blue    = "#0000ff";
#my $green   = "#136302";
#my $warning = "#ee2222";

my @new_member = ();
my %image      = ();
my %image_slot = ();
my %room       = ();
my @attr = qw(cn 
	cipuxNetworkAddress 
	cipuxNetworkMask 
	cipuxGatewayAddress 
	cipuxGatewayMask);

&log($SCRIPT,"="x76);

# +=======================================================================+
# || check if the LDAP is there                                          ||
# +=======================================================================+
if($cibot_ldap_status eq 'offline'){
  &cat_header($remote_user,\&header,\&help_search_link,\&text);
  print &cat_error(&text('_error_no_ldap_connect'));
  exit(0);
}

&cibot_get_ldap_config();

my ($result,$role) = &cibot_acl($SCRIPT,$remote_user);
&cat_header($remote_user,\&header,\&help_search_link,\&text);

# hostname, user, arrayref
print &cat_status_line(&get_system_hostname(),
                       "$remote_user ($role) -> $result",
                       [
                        &text('server'),
                        &text('status'),
                        $cipux{Customer},
                        &text('date'),
                        &text('version'),
                        $ldap{CipUX}{CipUX_Institution_Name}
                       ]
                      );

# +=======================================================================+
# ||  CAT ACL check                                                      ||
# +=======================================================================+
if($result ne 'ok'){
  print "<h1>".&text('access_denied')."</h1>";
  my $error = &text('access_denied_explanation',
                   "<b>$remote_user</b>",
                   "<b>$role</b>");
  &log($SCRIPT,$error);
  print &cat_error($error);
  &cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});
  exit(0)
}

# +=======================================================================+
# || Environment                                                         ||
# +=======================================================================+
&log($SCRIPT,"- ReadParse...");
ReadParse();# webmin

my $action    = $in{'action'} if defined($in{'action'});# action
&log($SCRIPT,"- \$action = [$action]");

foreach(sort keys %in){
  &log($SCRIPT,"- IN: [$_] = [$in{$_}]") if defined($in{$_});
}

# +=======================================================================+
# || Prepare                                                             ||
# +=======================================================================+

# $cmd = "ls /tftpboot/cipux/image";
use vars qw($tb);


my @room=`cipux_task_list_rooms`;
foreach(@room){
  chomp();
  &log($SCRIPT,"ROOM $_");
}

print "<h1>$text{'roomadmin_title'}</h1>";


# $cmd = "ls /tftpboot/cipux/image";
# &log($SCRIPT,"CMD '$cmd'");
# my @dir = `$cmd`;
# if($DEBUG){
#   foreach(@dir){
#     my $file = $_;
#     chomp($file);
#     &log($SCRIPT,"found file $file");
#   }
# }
#
# foreach(@dir){
#   if(/\.tar\.gz$/){
#     chomp();
#     s/_\d+\.tar\.gz$|\.tar\.gz$//g;
#     $image{$_}=$_;
#   }
# }

# get all image slot names from LDAP

 $cmd = "cipux_get_value -S -e 'cipuxImageSlotName'";
 &log($SCRIPT,"CMD ($cmd)");
 my @image_slot = `$cmd`;

 foreach my $line (@image_slot){
  my($image_slot,$image)=split("\t",$line);
  chomp($image);
  $image_slot{$image_slot}=$image;
 }

 if($DEBUG){
   foreach(keys %image_slot){
     &log($SCRIPT,"got image slot ($_) with image slot name ($image_slot{$_})");
   }
 }

# get currend room image names from LDAP

 $cmd = "cipux_get_value -R -e 'cipuxImageSlotNumber'";
 &log($SCRIPT,"CMD ($cmd)");
 my @image = `$cmd`;

 foreach my $line (@image){
  my($image_slot,$image)=split("\t",$line);
  chomp($image);
  $image{$image_slot}=$image;
 } 

 if($DEBUG){
   foreach(keys %image){
     &log($SCRIPT,"got room ($_) with image number ($image{$_}) with name ($image_slot{$image{$_}})");
   }
 }

# &content();

# +=======================================================================+
# || Main                                                                ||
# +=======================================================================+

# .-----------------------------------------------------------------------.
# | Change room                                                           |
# .-----------------------------------------------------------------------.

if($action eq "$text{'roomadmin_apply'}"){
  &log($SCRIPT,"APPLY: change rooms");
  foreach my $r (@room){
    &log($SCRIPT,"apply to room '$r' with former ($image{$r}) new '$in{$r}'");
    if($image{$r} ne $in{$r}){# only if changed
      my $cmd = "cipux_set_value";
      $cmd   .= " -r '$r' -e 'cipuxImageSlotNumber' -v '$in{$r}'";
      &log($SCRIPT,"CMD ($cmd)");
      $image{$r}=$in{$r};# or we have to querry LDAP!
      my @output = `$cmd`;
    }
  }

  print "<hr noshade>";
  if($output[0]=~m/ERROR/){
    foreach (@output){
      print "OUTPUT $_<br>";
    }
  }else{
    foreach (@room){
      print "$text{'roomadmin_apply_image'} <b>$in{$_}</b> ($image_slot{$in{$_}}) ";
      print "$text{'roomadmin_for'} <b>$_</b><br>";
    }
  }
  print "<hr noshade><br>";

  # read template
#  my @tpl = `cat $dir/room.tpl`;
#  if($DEBUG){
#    &log($SCRIPT,"<h3>TEMPLATE: '$dir/room.tpl'</h3><verbatim>");
#    foreach(@tpl){
#      &log($SCRIPT,"TPL:$_");
#    }
#  }
#  foreach my $r (@room){
#    chomp($r);
#    &log($SCRIPT,"</verbatim><h3>ROOM '$r' IMAGE '$in{$r}'</h3>");
#    my @tmp=@tpl;
#    foreach (@tmp){
#      s/<SE::CIPUX_ROOM>/$r/eg;
#      s/<SE::CIPUX_IMAGE>/$in{$r}/eg;
#      &log($SCRIPT,"TPL2:$_");
#    }
#    # write new 10.10.118.0.conf META: write error code!
#    my $filename = $dir."/".$filename{$r}.".conf";
#    &log($SCRIPT,"WRITE '$filename'");
#    open(CONF,">$filename") or die "Can't write on file: '$filename'!";
#    foreach (@tmp){
#      print CONF $_; 
#    }
#    close(CONF);
#  }
#  print "<hr noshade>";
#  if($output[0]=~m/ERROR/){
#    foreach (@output){
#      print "OUTPUT $_<br>";
#    }
#  }else{
#    foreach (@room){
#      print "$text{'roomadmin_apply_image'} <b>$in{$_}</b> ";
#      print "$text{'roomadmin_for'} <b>$_</b><br>";
#    }
#  }
#  print "<hr noshade><br>";
  my $out = `cipux_bot_deploy_conf`;
  if(defined($out)){
    if($out ne ""){
      print "<hr noshade><br>";
      print "OUT: $out";
      print "<hr noshade><br>";
    }
  }
#  &content();
}
# .-----------------------------------------------------------------------.
# | add room                                                              |
# .-----------------------------------------------------------------------.
if(defined($in{add_room})){
  &log($SCRIPT,"* add room");
  # CN network_address network_mask gateway_address gateway_mask
  my $cmd = "cipux_task_create_room ";
  foreach (@attr){
    $cmd .= " $in{$_} ";
  }
  &log($SCRIPT,"* cmd [$cmd]");
  `$cmd`;
  @room = `cipux_task_list_rooms`;
}	

# .-----------------------------------------------------------------------.
# | chamge admin data                                                     |
# .-----------------------------------------------------------------------.
if(defined($in{admin_change_room})){
  &log($SCRIPT,"* change admin data");
  my $cmd = "cipux_set_value -r $in{cn} ";
  print "<hr noshade><ul>";
  foreach (@attr){
    if($_ ne 'cn'){
      my $exec_cmd = $cmd . "-e $_ -v '$in{$_}'";
      &log($SCRIPT,"* exec cmd [$exec_cmd]");
      print "<li>". &text('roomadmin_changing_attribute',$_,$in{$_})."</li>";
      `$exec_cmd`;
    }
  }
  print "</ul><hr noshade>";
}

# .-----------------------------------------------------------------------.
# | Main view                                                             |
# .-----------------------------------------------------------------------.

$PART ="Main_View";

&log($SCRIPT,"begin printing table");

print "<form method=post action='roomadmin.cgi'>";
print "<table border=1>";
print "<tr $tb>";
print "<th>$text{'roomadmin_room'}</th>";
print "<th>$text{'roomadmin_image'}</th>";
print "</tr>";
foreach my $r (sort @room){
  chomp();
  print "<tr $cb><td>";
  print "$r</td><td>";
  print "<select name='$r' size=1>";
  foreach my $is (sort keys %image_slot){
    chomp($is);
    &log($SCRIPT,"process IS-name($image_slot{$is}) IS($is) R($r) R-Img($image{$r})");
     if($image{$r} eq $is){
#    if($image_slot{$is} eq $image{$is}){
      print "<option value='$is' selected>";
      &log($SCRIPT,"- selected table line: img ($image{$r}) with name ($image_slot{$is})");
    }else{
      print "<option value='$is' >";
      &log($SCRIPT,"- possible to choose: img ($is) with name ($image_slot{$is})");
    }
    print "$image_slot{$is}";
    print "</option>";
  }
  print "</select>";
  print "</td></tr>";
}
print "</table>";
print "<br>";
print " <input type=submit value='$text{'roomadmin_apply'}' name='action' >";
print "</form>";

print "<br><br>";
print "<table width=40% cellpadding=5 cellspacing=5 border=0 $cb>";
#print "<tr $cb><td><font color=$explain>$text{'roomadmin_logout_hint'}</font></td></tr>";
print "</table>";
&log($SCRIPT,"end printing table");

if($role eq 'admin' or $role eq  '$assistant'){
  # /-----------------------------------------------------------------------\
  # | main view for admin                                                   |
  # \-----------------------------------------------------------------------/
  print &cat_table_header(6,$tb,&text('roomadmin_room'));
  my @head = ();
  foreach (@attr){
    push(@head,&text($_)); 
  }	  
  push(@head,&text('action'));
  print &cat_table_row([1,1,1,1,1,1], [$tb,$tb,$tb,$tb,$tb,$tb],\@head);
  foreach my $r (sort @room){
    chomp($r);	  
    my @value =();
    foreach my $attr (@attr){	    
      my $v = `cipux_get_value -r $r -e $attr`;
      chomp($v);
      if($attr eq 'cn'){
        push(@value,"$v<form method=post action='roomadmin.cgi'>");
      }else{
        push(@value,"<input type=text value='$v' name='$attr'>");
      }
    }
    push(@value,"
	          <input type=submit value='$text{'roomadmin_apply'}' name='admin_change_room'>
		  <input type=hidden value='$r' name='cn'>
		  </form>");
    print &cat_table_row([1,0,0,0,0,0],[$cb,'','','','',$cb],\@value);
  }
  print &cat_table_footer();
  #  print " <input type=submit value='$text{'roomadmin_apply'}' name='add_room' >";
  print "<br>";

  # /-----------------------------------------------------------------------\
  # | admin and assisetent view: room add                                   |
  # \-----------------------------------------------------------------------/
  # cipux_task_create_room CN network_address network_mask gateway_address gateway_mak
  print "<form method=post action='roomadmin.cgi'>";
  print &cat_table_header(2,$tb,&text('roomadmin_add_room'));
  print &cat_table_row([1,1], [$tb,$tb],[&text('attribute'),&text('value')]);
  foreach my $attr (@attr){
    my $input = "<input type=text value='' name='$attr' >";
    print &cat_table_row([1,0], [$cb,'' ],[&text($attr),$input]);
  }
  print &cat_table_footer();
  print " <input type=submit value='$text{'roomadmin_apply'}' name='add_room' >";
  print "</form>";

  print &cat_explain_message(&text('roomadmin_explain_id',&text('cn')),$cb);
}

# +=======================================================================+
# || Footer                                                              ||
# +=======================================================================+

&cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});

exit(0)

