#!/usr/bin/perl 
# +========================================================================+
# || CAT CipUX Administration Tool                                        ||
# || Webmin module: userdata.cgi                                          ||
# || for administration of CAT and CipUX                                  ||
# || (c) 2001,2002,2003,2005 by Christian Kuelker                         ||
# || License: GPLv2                                                       ||
# +========================================================================+

package userdata_cgi;

do '../web-lib.pl';
&init_config();

use CipUX::CiBot;
use CipUX::Cat;
use CipUX::Task;

my $BRAND    = "cipworx";
my $PROJECT  = "cipux";
my $SCRIPT   = "userdata.cgi";

my $error = 0; # if error = 1
my $set_userdata = 0; # if = 0 userdata; = 1 set net applicant data
my $application_form_send=0;
my $msg ='';
my $new_uid="";

&log($SCRIPT,"="x76);

&log($SCRIPT,"- save = [".&text('save')."].");

# +=======================================================================+
# || check if the LDAP is there                                          ||
# +=======================================================================+
if($cibot_ldap_status eq 'offline'){
  &cat_header($remote_user,\&header,\&help_search_link,\&text);
  print &cat_error(&text('_error_no_ldap_connect'));
  exit(0);
}


&cibot_get_ldap_config();
&log($SCRIPT,"- remote user [$remote_user]");

#if($result ne 'ok'){
#  print "<h1>$text('access_denied')}</h1>";
#  #print $text('access_denied_explanation',$remote_user,$role);
 # &cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});
 # exit(0);
#}

my ($result,$role) = &cibot_acl($SCRIPT,$remote_user);
&cat_header($remote_user,\&header,\&help_search_link,\&text);

# hostname, user, arrayref
print &cat_status_line(&get_system_hostname(),
                       $remote_user." ($role)",
		       [
			&text('server'),
			&text('status'),
			$cipux{Customer},
			&text('date'),
			&text('version'),
                        $ldap{CipUX}{CipUX_Institution_Name}
		       ]
		      );

# +=======================================================================+
# ||  CAT ACL check                                                      ||
# +=======================================================================+
if($result ne 'ok'){
  print "<h1>".&text('access_denied')."</h1>";
  my $error = &text('access_denied_explanation',
                   "<b>$remote_user</b>",
                   "<b>$role</b>");
  &log($SCRIPT,$error);
  print &cat_error($error);
  &cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});
  exit(0)
}

# +=======================================================================+
# || Environment                                                         ||
# +=======================================================================+
&log($SCRIPT,"- webmin: ReadParse...");
ReadParse();# webmin

my $system = $in{'system'}    if defined($in{'system'});# system

foreach(sort keys %in){
  &log($SCRIPT,"- IN: [$_] = [$in{$_}]") if defined($in{$_});
}

my $login=$in{login} if defined $in{login};

# =========================================================================+
#                    Config                                               ||
# =========================================================================+
my @user_data_option = qw(hidden visible editable);
my @user_application_option = qw(mandatory optional skip);

my(
   $userdata_aref,
   $userdata_href,
   $user_application_form_href
   ) = cibot_parse_userdata_conf;

# =========================================================================+
#                    check passwords                                      ||
# =========================================================================+
#if($in{save_userdata} eq &text("save")){
#  &log($SCRIPT,"* check passowrds");
#  if(defined($in{PASSWORD_1})){
#    # password 1 is defined
#    if(defined($in{PASSWORD_2})){
#      # password 2 is defined
#      if($in{PASSWORD_1} ne "" and $in{PASSWORD_2} ne ""){
#        # passwords are not empty
#	if($in{PASSWORD_1} eq $in{PASSWORD_2}){
#	  #password ar equal
#          $set_userdata=1;
#	  
#	}else{
#          # ERROR passwords ar not equal
#	  $error="error_password_mismatch";
#	  
#	}
#      }else{
#        # ERROR password is empty!
#        $error="error_empty_password_given";
#	
#      }
#    }else{
#      # ERROR password 2 is not defined! 
#       $error="error_password_not_defined";
#
#    }
#  }else{
#     # ERROR password 1 is not defined! 
#     $error="error_password_not_defined";
#  }	  
#}

# =========================================================================+
# ||                         save_userdata                                ||
# =========================================================================+
if(defined( $in{save_userdata})){
  &log($SCRIPT,"* save_userdata");
  foreach my $attribute (@$userdata_aref){
    if($attribute ne "PASSWORD"){
      if(defined($in{$attribute})){
        if($in{$attribute} ne ''){
           &log($SCRIPT, "- write [$attribute] value [$in{$attribute}]");
           system("cipux_set_value -u $login -e $attribute -v '$in{$attribute}'");
        }        
      }
    }
  }
}

# =========================================================================+
# ||                         print_applicationform                        ||
# =========================================================================+
if(defined($in{print_applicationform}) and defined($in{login})){
  &log($SCRIPT,"* print_applicationform");
  print "<ul><li>".&text('print_applicationform')."... </li>";
  my ($error,$f1,$f2) = &cibot_print_applicationform($in{login});
  if(defined($error)){
    &log($SCRIPT,"ERROR [$error]");	  
    print &cat_error(&text($error,$f1,$f2));
  }else{	  
    print "<li>".&text('applicationform_was_send_to_printer')."</li></ul>";
  }
}

# =========================================================================+
# ||                         apply_applicationform                        ||
# =========================================================================+
if(defined($in{apply_applicationform})){
  &log($SCRIPT,"* apply_applicationform");
  system("cipux_task_enable_user $login");
}

# =========================================================================+
# ||                         check data                                   ||
# =========================================================================+
if($set_userdata and not $error){
  &log($SCRIPT,"* check data");
  foreach my $attribute (@$userdata_aref){
    if($$user_application_form_href{$attribute} eq "mandatory"){
      if($attribute ne "PASSWORD"){	    
        &log($SCRIPT, "- test [$attribute]");
        if($in{$attribute} eq ''){
	  &log($SCRIPT, "raise error for attribute [$attribute] [".&text($attribute)."]");
          $error="error_empty_field";
          $msg=&text($attribute);
        }
      }
    }	    
  }	  
  if(not defined($in{cipuxFirstname})){
    $error="error_empty_firstname";
  }
  if(not defined($in{cipuxLastname})){
    $error="error_empty_lastname";
  }
}	

  
# =========================================================================+
# ||                         ERROR                                        ||
# =========================================================================+
if($error){
	#print ERROR;
  if($msg eq ''){
    print &cat_error(&text($error));
    &log($SCRIPT,"ERROR: $error [".&text($error)."]");
  }else{
    print &cat_error(&text($error,$msg));
    &log($SCRIPT,"ERROR: $error [".&text($error,$msg)."]");
 }
}

# =========================================================================+
# ||                         SET DATA                                     ||
# =========================================================================+
#

#cipux_task_create_applicant firstname lastname role password
if(not $error and  $set_userdata){
$new_uid = &cipux_task_create_applicant('cgi',$in{cipuxFirstname},$in{cipuxLastname},'student',$in{PASSWORD_1});
&log($SCRIPT,"CMD [cipux_task_create_applicant $in{cipuxFirstname} $in{cipuxLastname} 'student' $in{PASSWORD_1}]");
chomp($new_uid);
foreach my $attribute (@$userdata_aref){
  if(defined($in{$attribute})){
    my $cmd = "cipux_set_value -u $new_uid -e $attribute -v '$in{$attribute}'";
    &log($SCRIPT,"CMD [$cmd]");
    `$cmd`; 
  }
  $application_form_send=1;
}
}
# =========================================================================+
# ||                         Main                                         ||
# =========================================================================+

if(defined($login)){
  print "<h2>".&text('userdata.cgi',$login)."</h2>";

  # status
  my $status = `cipux_get_value -u $login -e cipuxStatus`;
  chomp($status);
  my $status_image = '';
  if($status eq 'pending'){
    $status_image = " <img src='images/w.png' align=middle alt='".&text('pending')."' border=0>";
  }elsif($status eq 'alerting'){
    $status_image = "<img src='images/c.png' align=middle alt='".&text('alerting')."' border=0>";
  }elsif($status eq 'idle'){
    $status_image = "<img src='images/r.png' align=middle alt='".&text('idle')."' border=0>";
  }else{
    $status_image = "<img src='images/u.png' align=middle alt='".&text('unknown')."' border=0>";
  }
  #print &cat_table_header(2,$tb,&text('userdata.cgi',$login));
  #print &cat_table_row([1,0],[$tb,'' ], [&text('status').": ",$status_image]);
  #print &cat_table_footer ."<br>";

  print "<form method=post action='userdata.cgi'>";
  print &cat_table_header(2,$tb,&text('userdata.cgi',$login));
  foreach my $attribute (@$userdata_aref){
    my $value="";	  
    if(defined($in{$attribute})){
       $value = "value='$in{$attribute}'";	    
    }	    
      if($attribute eq "PASSWORD"){
        #        print &cat_table_row([1,0],[$tb,'' ], [&text('new_password1'), "<input type=password size=100 name='".$attribute."_1' $value>"]);
	#       print &cat_table_row([1,0],[$tb,'' ], [&text('new_password2'), "<input type=password size=100 name='".$attribute."_2' $value>"]);
      }elsif($attribute eq 'uid' or $attribute eq 'dn' ){
	my $value = `cipux_get_value -u $login -e $attribute`;
        print &cat_table_row([1,0],[$tb,'' ], [$attribute,$value]);
        if($attribute eq 'uid'){
          print &cat_table_row([1,0],[$tb,'' ], [&text('status'),$status_image." (".&text($status).")"]);
        }
      }else{
	my $optional = "*" if $$user_application_form_href{$attribute} ne "mandatory";
	my $value = `cipux_get_value -u $login -e $attribute`;
        print &cat_table_row([1,0],[$tb,'' ], [&text($attribute).": $optional", "<input type=text size=100 name='$attribute' value='$value'>"]);
      }
  }
  print &cat_table_footer ."<br>";
  print "<input type=submit name=save_userdata value='".&text('save')."'>";
  print "<input type=hidden name=login value='$login'>";
  if($status eq 'pending'){
    print "<input type=submit name=print_applicationform value='".&text('print_applicationform')."'>";
    print "<input type=submit name=apply_applicationform value='".&text('apply_applicationform')."'>";
  }
  print "</form>\n";

    print &cat_explain_message("*: ".&text('optional'),$cb);
}else{
  print "<h2>".&text('users')."</h2>";
  my @users = `cipux_task_list_users`;
  foreach (@users){
    chomp;
    print "<a href='/cat/$SCRIPT?login=$_'>$_</a><br>";
  }
}
#print "<br>";
#print "<img src='/cat/images/left.png' border=0>";
#print " <a href='tutoradmin.cgi'>".$text{back_to_tutoradmin}."</a>";
#print "<br>";

# +=======================================================================+
# || Footer                                                              ||
# +=======================================================================+
&cat_footer($remote_user,\&footer,$ldap{CipUX}{Cipux_Support});

exit(0);
